USE [WaspTrackInventory]
GO


print '----------------------------'
print '--                          '
print '--  DROP PROC SECTION       '
print '--                          '
print '----------------------------'



if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpDeleteSalesTaxItem]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpDeleteSalesTaxItem]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpDeleteSalesTaxCode]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpDeleteSalesTaxCode]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpDeleteAccountCategories]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpDeleteAccountCategories]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpGetItemQtys]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpGetItemQtys]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpGetItemQtyAvailDetail]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpGetItemQtyAvailDetail]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpGetItemQtyPickOrderDetail]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpGetItemQtyPickOrderDetail]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpGetItemQtyPODetail]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpGetItemQtyPODetail]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpCustomerInfo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpCustomerInfo]
GO

/****** Object:  StoredProcedure [dbo].[SpCalcItemAvailFulfillLevel]    Script Date: 12/19/2012 08:58:35 ******/
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SpCalcItemAvailFulfillLevel]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SpCalcItemAvailFulfillLevel]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpConvertToGroupSecurity]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpConvertToGroupSecurity]
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SpAlertExpiredItems]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SpAlertExpiredItems]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpAlertItemPastDue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpAlertItemPastDue]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpCustomerInfoExt]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpCustomerInfoExt]
GO

if EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[SpSaveGridSettings]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SpSaveGridSettings]
GO


print '----------------------------'
print '--                          '
print '--  CREATE PROC SECTION     '
print '--                          '
print '----------------------------'




SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO



CREATE PROCEDURE SpDeleteSalesTaxItem (@pStatus int, @pSalesTaxId int) AS

update sales_tax set record_status = @pStatus  where tax_id = @pSalesTaxId

GO



SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO



CREATE PROCEDURE SpDeleteSalesTaxCode (@pStatus int, @pSalesTaxCodeId int) AS

update sales_tax_code set record_status = @pStatus  where tax_code_id = @pSalesTaxCodeId

GO

CREATE PROCEDURE [dbo].[SpDeleteAccountCategories] (@pStatus int, @pAccountCategoryId int) AS

update item_ext set account_category_id = 0 where account_category_id = @pAccountCategoryId

update account_categories set record_status = @pStatus  where account_category_id = @pAccountCategoryId


GO

SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO

CREATE PROCEDURE [SpGetItemQtys] (
			@ItemNumber varchar(31),
			@dtDueDate DateTime, 
			@nCompanyID int,
			@nExcludePOID int,
			@nExcludePickOrderID int
			) AS
BEGIN
	declare @nItemID int
	set @nItemID = 0
	
	declare @nItemType int
	set @nItemType = 1

	declare @dAvailableQty decimal(18,4)
	set @dAvailableQty = 0
	
	declare @dCheckedOutQty decimal(18,4)
	set @dCheckedOutQty = 0
	
	declare @dQtyInPickOrder decimal(18,4)
	set @dQtyInPickOrder = 0
	
	declare @dQtyInPO decimal(18,4)
	set @dQtyInPO = 0
	
	select @nItemID = isnull(item_id, 0), @nItemType = item_type, @dAvailableQty = isnull(qty_available, 0), @dCheckedOutQty = qty_checked_out
	from item
	where item_number = @ItemNumber
	and record_status = 1
	and company_id = @nCompanyID
	
	--SELECT DATEADD(dd, 0, DATEDIFF(dd, 0, GETDATE()))  will return back only the date part of current date, 0 as hour, min, second, millisecond
	
	if( @nItemType = 4 )
	begin
		--we need to substract the sub item qty on pick orders when we calculate the availability of the kit item
		select @dAvailableQty = isnull(floor(min((isnull(sub_item.qty_in_house, 0) - isnull(sub_item_qty_on_pick_order.qty, 0))/kit_item.quantity)), 0)
		from item
		inner join item_group_spec as kit_item on item.item_id = kit_item.item_id and kit_item.record_status = 1
		inner join item as sub_item on kit_item.sub_item_id = sub_item.item_id
		left outer join (select kit_item.sub_item_id, sum(request_quantity - picked_quantity) as qty
						from item, item_group_spec as kit_item, pick_order, pick_order_detail
						where item.item_id = @nItemID
						and item.item_id = kit_item.item_id
						and kit_item.record_status = 1	
						and pick_order_detail.item_id = kit_item.sub_item_id
						and (pick_order.due_date is null or dateadd(dd, 0, datediff(dd, 0, pick_order.due_date)) <= dateadd(dd, 0, datediff(dd, 0, @dtDueDate)) )
						and pick_order.order_status in (1, 2, 3)
						and pick_order.record_status = 1
						and pick_order.company_id = 1
						and pick_order.pick_order_id = pick_order_detail.pick_order_id
						and pick_order_detail.record_status = 1
						group by kit_item.sub_item_id) as sub_item_qty_on_pick_order 
													   on sub_item.item_id = sub_item_qty_on_pick_order.sub_item_id 
		where item.item_id = @nItemID
	end
	
	--we get qty in all pos disregard its due date
	select @dQtyInPO = isnull(sum(quantity_ordered - quantity_received), 0)
	from po_detail, po_master
	where po_detail.item_id = @nItemID
	and po_detail.po_id = po_master.po_id
	--and (po_master.due_date is null or dateadd(dd, 0, datediff(dd, 0, po_master.due_date)) <= dateadd(dd, 0, datediff(dd, 0, @dtDueDate)) )  --compare only the date part
	and po_master.po_id != @nExcludePOID
	and po_master.po_status in (1, 2, 3)
	and po_master.record_status = 1
	and po_master.company_id = @nCompanyID
	and po_detail.record_status = 1

	select @dQtyInPickOrder = isnull(sum(request_quantity - picked_quantity), 0)
	from pick_order, pick_order_detail
	where pick_order_detail.item_id = @nItemID
	and (pick_order.due_date is null or dateadd(dd, 0, datediff(dd, 0, pick_order.due_date)) <= dateadd(dd, 0, datediff(dd, 0, @dtDueDate)))  --compare only the date part
	and pick_order.pick_order_id != @nExcludePickOrderID
	and pick_order.order_status in (1, 2, 3)
	and pick_order.record_status = 1
	and pick_order.company_id = @nCompanyID
	and pick_order.pick_order_id = pick_order_detail.pick_order_id
	and pick_order_detail.record_status = 1
	
	declare @dQtyRelatedToKitOnPickOrder decimal
	set @dQtyRelatedToKitOnPickOrder = 0
	
	--if item is not kit item, we need to include the qty in kits that are on pick orders
	if( @nItemType <> 4 )
	begin
		select @dQtyRelatedToKitOnPickOrder = isnull(sum((request_quantity - picked_quantity ) * kit_item.quantity),0)
		from item_group_spec as kit_item, pick_order, pick_order_detail
		where kit_item.sub_item_id = @nItemID
		and kit_item.record_status = 1	
		and pick_order_detail.item_id = kit_item.item_id
		and (pick_order.due_date is null or dateadd(dd, 0, datediff(dd, 0, pick_order.due_date)) <= dateadd(dd, 0, datediff(dd, 0, @dtDueDate)))  --compare only the date part
		and pick_order.order_status in (1, 2, 3)
		and pick_order.record_status = 1
		and pick_order.company_id = 1
		and pick_order.pick_order_id = pick_order_detail.pick_order_id
		and pick_order_detail.record_status = 1
		group by kit_item.item_id
	end

	select @dQtyInPickOrder = @dQtyInPickOrder + @dQtyRelatedToKitOnPickOrder
	
	select @nItemID as id, @dAvailableQty as qty_avail, @dCheckedOutQty as qty_checkedout, @dQtyInPickOrder as qty_pickorder, @dQtyInPO as qty_po
END

GO

SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO

CREATE PROCEDURE [SpGetItemQtyAvailDetail] (
			@ItemNumber varchar(31),
			@nCompanyID int
			) AS
BEGIN
	select sites.site_name, SUM(inv.quantity)
	from inventory as inv, location as loc, sites, item
	where item.item_number = @ItemNumber
	and item.record_status = 1
	and item.company_id = @nCompanyID
	and inv.item_id = item.item_id
	and inv.location_id = loc.location_id
	and inv.record_status = 1
	and loc.site_id = sites.site_id
	group by sites.site_id, sites.site_name
END
GO

SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO

CREATE PROCEDURE [SpGetItemQtyPickOrderDetail] (
			@ItemNumber varchar(31),
			@dtDueDate DateTime, 
			@nCompanyID int,
			@nExcludePickOrderID int
			) AS
BEGIN
	declare @nItemID int
	set @nItemID = 0
	
	select @nItemID = isnull(item_id, 0)
	from item
	where item_number = @ItemNumber
	and record_status = 1
	and company_id = @nCompanyID

	select due_date, order_number, (request_quantity - picked_quantity) as expected_qty
	from pick_order, pick_order_detail
	where pick_order_detail.item_id = @nItemID
	and (pick_order.due_date is null or dateadd(dd, 0, datediff(dd, 0, pick_order.due_date)) <= dateadd(dd, 0, datediff(dd, 0, @dtDueDate)))  --compare only the date part
	and pick_order.pick_order_id != @nExcludePickOrderID
	and pick_order.order_status in (1, 2, 3)
	and pick_order.record_status = 1
	and pick_order.company_id = 1
	and pick_order.pick_order_id = pick_order_detail.pick_order_id
	and pick_order_detail.record_status = 1
	
	union
	
	--include qty in kits that are on pick orders
	select due_date, order_number, ((request_quantity - picked_quantity ) * kit_item.quantity) as expected_qty
	from item_group_spec as kit_item, pick_order, pick_order_detail
	where kit_item.sub_item_id = @nItemID
	and kit_item.record_status = 1	
	and pick_order_detail.item_id = kit_item.item_id
	and (pick_order.due_date is null or dateadd(dd, 0, datediff(dd, 0, pick_order.due_date)) <= dateadd(dd, 0, datediff(dd, 0, @dtDueDate)))  --compare only the date part
	and pick_order.order_status in (1, 2, 3)
	and pick_order.record_status = 1
	and pick_order.company_id = 1
	and pick_order.pick_order_id = pick_order_detail.pick_order_id
	and pick_order_detail.record_status = 1
END

GO

SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO

CREATE PROCEDURE [SpGetItemQtyPODetail] (
			@ItemNumber varchar(31),
			@dtDueDate DateTime, 
			@nCompanyID int,
			@nExcludePOID int
			) AS
BEGIN
	declare @nItemID int
	set @nItemID = 0
	
	select @nItemID = isnull(item_id, 0)
	from item
	where item_number = @ItemNumber
	and record_status = 1
	and company_id = @nCompanyID

	--we get qty in all pos disregard its due date
	select due_date, po_number, (quantity_ordered - quantity_received) as expected_qty
	from po_detail, po_master
	where po_detail.item_id = @nItemID
	and po_detail.po_id = po_master.po_id
	--and (po_master.due_date is null or dateadd(dd, 0, datediff(dd, 0, po_master.due_date)) <= dateadd(dd, 0, datediff(dd, 0, @dtDueDate)) )  --compare only the date part
	and po_master.po_id != @nExcludePOID
	and po_master.po_status in (1, 2, 3)
	and po_master.record_status = 1
	and po_master.company_id = 1
	and po_detail.record_status = 1
	order by due_date
END

GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [SpCustomerInfo]

AS
BEGIN

SET NOCOUNT ON

SELECT     
customer_id, 
customer_number, 
dbo.customer.name, 
company_name, 
email, 
department, 
date_added, 
record_status,
company_id

into #t1
FROM         dbo.customer

select  Customer_id, phone_number, extension
into #t2
FROM         dbo.Customer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Customer.Customer_id AND dbo.phone.table_name = 'Customer' and dbo.phone.phone_type_id=1

select  Customer_id,phone_number as 'Fax'
into #t3
FROM         dbo.Customer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Customer.Customer_id AND dbo.phone.table_name = 'Customer' and dbo.phone.phone_type_id=3

select Customer_id,phone_number as 'hPhone' 
into #t4
FROM         dbo.Customer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Customer.Customer_id AND dbo.phone.table_name = 'Customer' and dbo.phone.phone_type_id=4

select Customer_id,phone_number as 'cCell' 
into #t5
FROM         dbo.Customer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Customer.Customer_id AND  dbo.phone.table_name = 'Customer' and dbo.phone.phone_type_id=2

SELECT dbo.customer.customer_id,dbo.sales_tax_code.tax_code as 'tax_code'                      
into #t6
FROM dbo.Customer LEFT OUTER JOIN 
		dbo.customer_ext ON dbo.customer_ext.customer_id = dbo.customer.customer_id LEFT OUTER JOIN
		dbo.sales_tax_code ON dbo.sales_tax_code.tax_code_id = dbo.customer_ext.sales_tax_code_id

SET NOCOUNT OFF

SELECT     
#t1.Customer_id, 
customer_number,
#t1.name, 
company_name, 
email, 
department, 
date_added, 
record_status,
company_id,
phone_number, 
extension,
fax,
hphone,
ccell,
tax_code


from #t1 inner join #t2 on #t1.Customer_id = #t2.Customer_id
inner join #t3 on #t3.Customer_id = #t2.Customer_id
inner join #t4 on #t4.Customer_id = #t2.Customer_id
inner join #t5 on #t5.Customer_id = #t2.Customer_id
inner join #t6 on #t6.customer_id = #t2.customer_id
where #t1.Customer_id >0

drop table #t1
drop table #t2
drop table #t3
drop table #t4
drop table #t5
drop table #t6

END

GO





CREATE PROCEDURE [SpCalcItemAvailFulfillLevel] (@pForecastEndDate datetime, @pAlertsOnly int, @pShowPickOrdersOnly int)  AS
BEGIN


DECLARE @t1 TABLE ([item_id] [int],
	[po_id] [int],
	[pick_order_id] [int],
	[due_date] [datetime],
	[quantity] [decimal](18, 4),
	[total_qty] [decimal](18, 4)
) 

-- pick order: step 1 get all inventory and assembly items
-- to exclude manual line item, we cannot use item.item_type in (1, 5), because we join by item.item_id, manual line item item id is 0, but item_id 0's item type is 1
SELECT     pick_order_detail.item_id, 0 AS po_id, pick_order_detail.pick_order_id, CASE WHEN due_date IS NULL THEN CONVERT(DATETIME, '9999-12-31', 101) 
                      ELSE due_date END AS due_date, - (pick_order_detail.request_quantity - pick_order_detail.picked_quantity) AS quantity, 0 AS total_qty
INTO #t1
FROM         pick_order_detail INNER JOIN
                      pick_order ON pick_order.pick_order_id = pick_order_detail.pick_order_id INNER JOIN
                      item ON pick_order_detail.item_id = item.item_id
WHERE     (pick_order_detail.request_quantity - pick_order_detail.picked_quantity > 0) AND (pick_order_detail.record_status = 1) AND (pick_order_detail.company_id = 1) AND 
                      (pick_order.order_status < 10) and (pick_order_detail.line_item_type in (1, 5))

-- pick order: step 2 get all kit items and break them into inventory and assembly items
INSERT INTO #t1
SELECT     subitem.item_id, 0 AS po_id, pick_order_detail.pick_order_id, CASE WHEN due_date IS NULL THEN CONVERT(DATETIME, '9999-12-31', 101) 
                      ELSE due_date END AS due_date, - (pick_order_detail.request_quantity - pick_order_detail.picked_quantity)* item_group_spec.quantity AS quantity,
                      0 AS total_qty
FROM         item_group_spec INNER JOIN
                      pick_order_detail INNER JOIN
                      pick_order ON pick_order.pick_order_id = pick_order_detail.pick_order_id ON item_group_spec.item_id = pick_order_detail.item_id INNER JOIN
                      item ON pick_order_detail.item_id = item.item_id INNER JOIN
                      item AS subitem ON item_group_spec.sub_item_id = subitem.item_id
WHERE     (pick_order_detail.request_quantity - pick_order_detail.picked_quantity > 0) AND (pick_order_detail.record_status = 1) AND (pick_order_detail.company_id = 1) AND 
                      (pick_order.order_status < 10) AND (item.item_type IN (4)) and (subitem.item_type in (1, 5))

-- pick order: step 3 sum up the same items on the same pick order
insert into @t1
SELECT item_id, po_id, pick_order_id, due_date, 
       SUM(quantity) as quantity,  0
FROM #t1
GROUP BY item_id, po_id, pick_order_id, due_date


DROP TABLE #t1


-- purchase order
insert into @t1
select po_detail.item_id, po_detail.po_id, 0 as pick_order_id, 
       CASE WHEN due_date IS NULL THEN CONVERT(DATETIME, '9999-12-31', 101) ELSE due_date END as due_date, 
       (quantity_ordered-quantity_received) * unit_of_measure.quantity_eaches as quantity,  0 as total_qty
FROM dbo.po_detail inner join dbo.po_master ON dbo.po_master.po_id = po_detail.po_id LEFT OUTER JOIN
	unit_of_measure ON po_detail.uom_id = unit_of_measure.uom_id 
WHERE (quantity_ordered-quantity_received) > 0 and po_detail.record_status = 1 and po_detail.company_id = 1
and po_status < 10


-- real time inventory counts
insert into @t1
select item_id, 0 as po_id, 0 as pick_order_id, CONVERT(DATETIME, '1900-1-1', 101) as due_date, 
		qty_available as quantity,  0 as total_qty
from dbo.item where item_id in (select distinct item_id from @t1) and item_type in (1, 5)

--select * from @t1 order by item_id, due_date
select * into #t2 from @t1 order by item_id, due_date

declare  @item_id  int
DECLARE  @RunningTotal decimal(18, 4)

DECLARE  item_cur CURSOR for select distinct item_id from @t1 order by item_id

open item_cur

fetch next from item_cur into @item_id

WHILE @@FETCH_STATUS = 0
BEGIN

set @RunningTotal = 0

UPDATE #t2 SET @RunningTotal = total_qty = @RunningTotal + quantity FROM #t2 where item_id = @item_id

fetch next from item_cur into @item_id
END

close item_cur
deallocate item_cur

--select * from #t2

if (@pForecastEndDate is NULL)
BEGIN
	-- there is no Forecast End Date, show all data
	if (@pAlertsOnly = 1)
	BEGIN
		-- only show items that ever dropped to negative
		SELECT		item.item_number, item.description as description, pick_order.order_number, po_master.po_number AS po_number, 
					#t2.*, pick_order.customer_id as customer_id, customer.customer_number AS customer_number, customer.name AS customer_name, 
					supplier.supplier_number, supplier.name AS supplier_name, po_master.supplier_id AS supplier_id, item.item_type			
		FROM        customer INNER JOIN
							  pick_order ON customer.customer_id = pick_order.customer_id RIGHT OUTER JOIN
							  supplier INNER JOIN
							  po_master ON supplier.supplier_id = po_master.supplier_id RIGHT OUTER JOIN
							  #t2 INNER JOIN
							  item ON #t2.item_id = item.item_id ON po_master.po_id = #t2.po_id ON pick_order.pick_order_id = #t2.pick_order_id
		where #t2.item_id in (SELECT distinct item_id FROM #t2 WHERE total_qty < 0)
		order by #t2.item_id, #t2.due_date
	END
	else
	BEGIN
		SELECT		item.item_number, item.description as description, pick_order.order_number, po_master.po_number AS po_number, 
						#t2.*, pick_order.customer_id as customer_id, customer.customer_number AS customer_number, customer.name AS customer_name, 
						supplier.supplier_number, supplier.name AS supplier_name, po_master.supplier_id AS supplier_id, item.item_type
		FROM        customer INNER JOIN
							  pick_order ON customer.customer_id = pick_order.customer_id RIGHT OUTER JOIN
							  supplier INNER JOIN
							  po_master ON supplier.supplier_id = po_master.supplier_id RIGHT OUTER JOIN
							  #t2 INNER JOIN
							  item ON #t2.item_id = item.item_id ON po_master.po_id = #t2.po_id ON pick_order.pick_order_id = #t2.pick_order_id
		order by #t2.item_id, #t2.due_date
	END
end
else
BEGIN
	-- there is a Forecast End Date, 
	if (@pAlertsOnly = 1)
	BEGIN
		if (@pShowPickOrdersOnly = 1)
		BEGIN
			-- only show items that ever dropped to negative, and only show pick orders
			SELECT		#t2.item_id, #t2.po_id, #t2.pick_order_id, item.item_number, item.description as description, pick_order.order_number, 
					po_master.po_number AS po_number, #t2.due_date, abs(#t2.quantity) as quantity,  #t2.total_qty, 
						pick_order.customer_id as customer_id, customer.customer_number AS customer_number, customer.name AS customer_name, 
						supplier.supplier_number, supplier.name AS supplier_name, po_master.supplier_id AS supplier_id, item.item_type
			FROM        customer INNER JOIN
								  pick_order ON customer.customer_id = pick_order.customer_id RIGHT OUTER JOIN
								  supplier INNER JOIN
								  po_master ON supplier.supplier_id = po_master.supplier_id RIGHT OUTER JOIN
								  #t2 INNER JOIN
								  item ON #t2.item_id = item.item_id ON po_master.po_id = #t2.po_id ON pick_order.pick_order_id = #t2.pick_order_id
			where #t2.due_date < @pForecastEndDate AND 
				  #t2.item_id in (SELECT distinct item_id FROM #t2 WHERE total_qty < 0 AND due_date < @pForecastEndDate) and 
				  #t2.pick_order_id > 0
			order by #t2.item_id, #t2.due_date
		END
		ELSE
		BEGIN
			-- only show items that ever dropped to negative
			SELECT		item.item_number, item.description as description, pick_order.order_number, po_master.po_number AS po_number, 
							#t2.*, pick_order.customer_id as customer_id, customer.customer_number AS customer_number, customer.name AS customer_name, 
							supplier.supplier_number, supplier.name AS supplier_name, po_master.supplier_id AS supplier_id, item.item_type
			FROM        customer INNER JOIN
								  pick_order ON customer.customer_id = pick_order.customer_id RIGHT OUTER JOIN
								  supplier INNER JOIN
								  po_master ON supplier.supplier_id = po_master.supplier_id RIGHT OUTER JOIN
								  #t2 INNER JOIN
								  item ON #t2.item_id = item.item_id ON po_master.po_id = #t2.po_id ON pick_order.pick_order_id = #t2.pick_order_id
			where #t2.due_date < @pForecastEndDate AND #t2.item_id in 
						(SELECT distinct item_id FROM #t2 WHERE total_qty < 0 AND due_date < @pForecastEndDate)
			order by #t2.item_id, #t2.due_date
		END
	END
	else
	BEGIN
		-- show all data prior to the Forecast End Date
		SELECT		item.item_number, item.description as description, pick_order.order_number, po_master.po_number AS po_number, 
						#t2.*, pick_order.customer_id as customer_id, customer.customer_number AS customer_number, customer.name AS customer_name, 
						supplier.supplier_number, supplier.name AS supplier_name, po_master.supplier_id AS supplier_id, item.item_type
		FROM        customer INNER JOIN
							  pick_order ON customer.customer_id = pick_order.customer_id RIGHT OUTER JOIN
							  supplier INNER JOIN
							  po_master ON supplier.supplier_id = po_master.supplier_id RIGHT OUTER JOIN
							  #t2 INNER JOIN
							  item ON #t2.item_id = item.item_id ON po_master.po_id = #t2.po_id ON pick_order.pick_order_id = #t2.pick_order_id
		where #t2.due_date < @pForecastEndDate
		order by #t2.item_id, #t2.due_date
	END
END


drop table #t2

END


GO


-- =============================================================================
-- Description:	Convert user privileges to group privileges for version 6
-- =============================================================================
CREATE PROCEDURE [SpConvertToGroupSecurity]
AS
BEGIN
		--Temp table that holds a row for each user. These will be used to create the groups
	create table #temp_group 
	(temp_id int IDENTITY(1,1) NOT NULL,
	[user_id] int, 
	composite varchar(20),
	[add] int,
	adjust int,
	[admin] int,
	audit int,
--	approve int,
	[assembly] int,
	[backup] int,
	checkin int,
	checkout int,
	[delete] int,
	disassembly int,
	edit int,
	edit_price int,
	labels int,
	mobility int,
	[move] int,
	new int,
	pc int,
	pick int,
	[receive] int,
	remove int,
	reports int,
	upload int,
	view_price int, 
	group_id int,
	site_string varchar(50))

	DECLARE 
		@security_code varchar(30),
		@user_id int,
		@hasright int,
		@security_string varchar(20), -- the string that will have the composite security value
		@admin int,
		@add int,
		@adjust int,
		@audit int,
--		@approve int,
		@assembly int,
		@backup int,
		@checkin int,
		@checkout int,
		@delete int,
		@disassembly int,
		@edit int,
		@edit_price int,
		@labels int,
		@mobility int,
		@move int,
		@new int,
		@pc int,
		@pick int,
		@receive int,
		@remove int,
		@reports int,
		@upload int,
		@view_price int,
		@unique_comp varchar(20),
		@temp_id int,
		@count int,
		@group_name nvarchar(50),
		@group_id int,
		@site_id int,
		@unique_site varchar(2000), --will contain the unique composite value
		@site_string varchar(2000)  -- will contain the site ids for the user

	-- cursor to spin though the users
	declare user_cur CURSOR FOR  
		select [user_id] from [dbo].[users] where [user_id] > 1 and [record_status] = 1 and [group_id] < 2
	
	-- cursor to spin though the security privileges
	declare sec_priv_cur CURSOR FOR  
		select [security_code] from [dbo].[security_privileges] where [company_id] = 1 order by [security_code]	

	-- cursor for the temp table
	declare temp_group_cur CURSOR FOR 
		select distinct composite, site_string from #temp_group group by composite, site_string

	-- cursor for the sites
	declare site_cur CURSOR FOR 
		select site_id from sites where site_id >= 0	

	-- cursor for all the #temp_groups
	declare all_temp_cur CURSOR FOR 
		select group_id, [user_id] from #temp_group

	-- For each user
	open user_cur
	while 1=1
	BEGIN
		-- Clear the security string		
		set @security_string = ''
		
		-- Get the user id
		FETCH user_cur into @user_id
		if (@@fetch_status<>0) 
			GOTO out_of_users 		

		-- Clear the rights
		set @add = 0
		set @adjust = 0
		set @admin = 0
		set @assembly = 0
		set @audit = 0
		set @backup = 0
		set @checkin = 0
		set @checkout = 0
		set @delete = 0
		set @disassembly = 0
		set @edit = 0
		set @edit_price = 0
		set @labels = 0
		set @mobility = 0
		set @move = 0
		set @new = 0
		set @pc = 0
		set @pick = 0
		set @receive = 0
		set @remove = 0
		set @reports = 0
		set @upload = 0	
		set @view_price = 0
		
		--clear the site_string
		set @site_string = ','
		
		-- For each security_privilage
		open sec_priv_cur
		while 1=1
		BEGIN
			-- Get the security code
			FETCH sec_priv_cur into @security_code	
			if (@@fetch_status<>0) 
				GOTO out_of_sec_priv			

			-- If the user has rights to that code
			set @hasright = 0
			if exists (select [user_id] from dbo.user_privileges where [user_privileges].[user_id] = @user_id and security_code = @security_code and record_status = 1)
				begin
					-- then we add a 1 to the string
					set @security_string = @security_string + '1'
					-- and set the has right bit
					set @hasright = 1
				end
			else
				-- else we add a 0 to the string
				set @security_string = @security_string + '0'

			-- Based on the current code we are looking at set the rights to be added to the temp table
			if (@security_code = 'admin')
				set @admin = @hasright
			else if (@security_code = 'adjust')
				set @adjust = @hasright
			else if (@security_code = 'add')
				set @add = @hasright
			else if (@security_code = 'assembly')
				set @assembly = @hasright
			else if (@security_code = 'audit')
				set @audit = @hasright
			else if (@security_code = 'backup')
				set @backup = @hasright
			else if (@security_code = 'checkin')
				set @checkin = @hasright
			else if (@security_code = 'checkout')
				set @checkout = @hasright
			else if (@security_code = 'delete')
				set @delete = @hasright
			else if (@security_code = 'disassembly')
				set @disassembly = @hasright
			else if (@security_code = 'edit')
				set @edit = @hasright
			else if (@security_code = 'edit_price')
				set @edit_price = @hasright
			else if (@security_code = 'labels')
				set @labels = @hasright
			else if (@security_code = 'mobility')
				set @mobility = @hasright
			else if (@security_code = 'move')
				set @move = @hasright
			else if (@security_code = 'new')
				set @new = @hasright
			else if (@security_code = 'pc')
				set @pc = @hasright
			else if (@security_code = 'pick')
				set @pick = @hasright
			else if (@security_code = 'receive')
				set @receive = @hasright
			else if (@security_code = 'remove')
				set @remove = @hasright
			else if (@security_code = 'reports')
				set @reports = @hasright
			else if (@security_code = 'upload')
				set @upload = @hasright		
			else if (@security_code = 'view_price')
				set @view_price = @hasright	
		END
		out_of_sec_priv:
		close sec_priv_cur
		
		open site_cur
		while 1=1
		BEGIN
			FETCH site_cur into @site_id	
			if (@@fetch_status<>0) 
				GOTO out_of_site_cur
				
			--if user has access to the site
			if exists (select [user_id] from dbo.user_site where [user_site].[user_id] = @user_id and site_id = @site_id)
			begin
				-- then we add id to string
				set @site_string = @site_string + cast(@site_id AS varchar) + ','
			end
		END
		out_of_site_cur:
		close site_cur
		
		-- Add a row to the tempoary table
		insert into #temp_group ([user_id],composite,[add],adjust,[admin],[assembly],audit,[backup],checkin,checkout,[delete],disassembly,edit,edit_price,labels,mobility,[move],new,pc,pick,[receive],remove,reports,upload,view_price,site_string) 
			values (@user_id,@security_string,@add,@adjust,@admin,@assembly,@audit,@backup,@checkin,@checkout,@delete,@disassembly,@edit,@edit_price,
					@labels,@mobility,@move,@new,@pc,@pick,@receive,@remove,@reports,@upload,@view_price,@site_string)

	END
	out_of_users:
	close user_cur

	-- All employees are handled now use the temp table to create groups
	-- For each unique composite security string and site string
	open temp_group_cur
	set @count = 0
	while 1=1
	BEGIN
		fetch temp_group_cur into @unique_comp, @unique_site
		if (@@fetch_status<>0) 
			GOTO out_of_temp
		
		-- Create the new group name		
		set @count = @count +1
		set @group_name = 'Group '+convert(varchar(50),@count)
		
		-- Create a group
		insert into user_groups (group_name, group_description, record_status, company_id) VALUES (@group_name,@group_name,1,1)
		set @group_id = @@identity
		
		-- Put the new group id into each temp table for use later
		update #temp_group set group_id = @group_id where composite = @unique_comp and site_string = @unique_site
		
		-- For each user_privilege
		open sec_priv_cur
		while 1=1
		BEGIN
			-- Get the security code
			FETCH sec_priv_cur into @security_code	
			if (@@fetch_status<>0) 
				GOTO out_of_sec_priv_group

			--print @security_code

			-- Add a row into user_group_privileges for this group
			set @hasright = 0
			if (@security_code = 'add')
				BEGIN
					-- find out if this group has this privilege
					select top 1 @hasright = [add] from #temp_group where composite = @unique_comp
					-- if it does add it to the user_group_privileges table
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'adjust')
				BEGIN
					-- find out if this group has this privilege
					select top 1 @hasright = [adjust] from #temp_group where composite = @unique_comp
					-- if it does add it to the user_group_privileges table
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'admin')
				BEGIN
					-- find out if this group has this privilege
					select top 1 @hasright = [admin] from #temp_group where composite = @unique_comp
					-- if it does add it to the user_group_privileges table
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'assembly')
				BEGIN
					-- find out if this group has this privilege
					select top 1 @hasright = [assembly] from #temp_group where composite = @unique_comp
					-- if it does add it to the user_group_privileges table
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'audit')
				BEGIN
					select top 1 @hasright = [audit] from #temp_group where composite = @unique_comp					
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'backup')
				BEGIN
					select top 1 @hasright = [backup] from #temp_group where composite = @unique_comp					
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'backup')
				BEGIN
					select top 1 @hasright = [backup] from #temp_group where composite = @unique_comp
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'checkin')
				BEGIN
					-- find out if this group has this privilege
					select top 1 @hasright = [checkin] from #temp_group where composite = @unique_comp
					-- if it does add it to the user_group_privileges table
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'checkout')
				BEGIN
					select top 1 @hasright = [checkout] from #temp_group where composite = @unique_comp
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'delete')
				BEGIN
					select top 1 @hasright = [delete] from #temp_group where composite = @unique_comp
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'disassembly')
				BEGIN
					select top 1 @hasright = [disassembly] from #temp_group where composite = @unique_comp
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'edit')
				BEGIN
					select top 1 @hasright = [edit] from #temp_group where composite = @unique_comp
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'edit_price')
				BEGIN
					-- find out if this group has this privilege
					select top 1 @hasright = [edit_price] from #temp_group where composite = @unique_comp
					-- if it does add it to the user_group_privileges table
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'labels')
				BEGIN
					select top 1 @hasright = [labels] from #temp_group where composite = @unique_comp
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'mobility')
				BEGIN
					-- find out if this group has this privilege
					select top 1 @hasright = [mobility] from #temp_group where composite = @unique_comp
					-- if it does add it to the user_group_privileges table
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'move')
				BEGIN
					select top 1 @hasright = [move] from #temp_group where composite = @unique_comp
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'admin')
				BEGIN
					select top 1 @hasright = [admin] from #temp_group where composite = @unique_comp
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'new')
				BEGIN
					select top 1 @hasright = [new] from #temp_group where composite = @unique_comp
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'pc')
				BEGIN
					select top 1 @hasright = [pc] from #temp_group where composite = @unique_comp
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'pick')
				BEGIN
					select top 1 @hasright = [pick] from #temp_group where composite = @unique_comp
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'receive')
				BEGIN
					select top 1 @hasright = [receive] from #temp_group where composite = @unique_comp
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'remove')
				BEGIN
					-- find out if this group has this privilege
					select top 1 @hasright = [remove] from #temp_group where composite = @unique_comp
					-- if it does add it to the user_group_privileges table
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
			else if (@security_code = 'reports')
				BEGIN
					select top 1 @hasright = [reports] from #temp_group where composite = @unique_comp
					if (@hasright = 1)
					BEGIN
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
						insert into user_group_reports (group_id, rpt_id) VALUES (@group_id, 0)
					END
				END
			else if (@security_code = 'upload')
				BEGIN
					select top 1 @hasright = [upload] from #temp_group where composite = @unique_comp					
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1) 
				END
			else if (@security_code = 'view_price')
				BEGIN
					select top 1 @hasright = [view_price] from #temp_group where composite = @unique_comp					
					if (@hasright = 1)
						insert into user_group_privileges (group_id, security_code, record_status, company_id) VALUES (@group_id, @security_code, 1 ,1)
				END
		END
		out_of_sec_priv_group:
		close sec_priv_cur

		-- for each site
		open site_cur
		while 1=1
		BEGIN
			-- Get the site id
			FETCH site_cur into @site_id	
			if (@@fetch_status<>0) 
				GOTO out_of_sites
			
			-- parse through the site string to give correct access
			if(PATINDEX('%,' + cast(@site_id AS varchar) + ',%', @unique_site) <> 0)
				insert into user_group_sites (group_id, site_id) VALUES (@group_id, @site_id)
		END	
		out_of_sites:
		close site_cur
		
	END
	out_of_temp:

	-- For each user who is in this group			
	open all_temp_cur
	while 1=1
	BEGIN
		FETCH all_temp_cur into @group_id, @user_id	
		if (@@fetch_status<>0) 
			GOTO out_of_all_temp

		-- update the user to be a member of this group
		update users set group_id = @group_id where [user_id] = @user_id
	END	
	out_of_all_temp:
	close all_temp_cur
	
	
	DEALLOCATE user_cur
	DEALLOCATE sec_priv_cur
	DEALLOCATE site_cur
	DEALLOCATE temp_group_cur
	DEALLOCATE all_temp_cur
	drop table #temp_group
END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/****** Object:  StoredProcedure [dbo].[SpAlertExpiredItems]    Script Date: 02/13/2013 08:30:26 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

/****** Object:  StoredProcedure [dbo].[SpAlertExpiredItems]    Script Date: 02/04/2013 15:03:56 ******/
CREATE PROCEDURE [SpAlertExpiredItems] @nUserID int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    	declare @nNumberOfSite int
	set @nNumberOfSite = 0

	select @nNumberOfSite = count(*) from user_site where user_id = @nUserID

	if( @nNumberOfSite > 0 )
	begin
		declare @nSiteID int
		set @nSiteID = 0

		-- if user has privilege on only one site, check to see if site_id is 0
		if( @nNumberOfSite = 1 )
		begin
			select @nSiteID = site_id from user_site where user_id = @nUserID
		end
		
		-- if site id is 0, user @nUserID can access to all sites
		if( @nSiteID = 0 )
		begin
			SELECT item.item_id AS rec_id, item.item_number, 
				item.description AS item_desc, sites.site_name, location.code, 
				CONVERT(decimal(18, 1), SUM(trn.remaining_qty)) AS quantity, MIN(trn.date_acquired) AS oldest, MAX(trn.date_acquired) AS newest, 
				trn.pallet, trn.lot, trn.po, trn.date_code,
				CONVERT(decimal(18, 1), inv.min_stock_level) AS min_stock_level,
				CONVERT(decimal(18, 1), inv.max_stock_level) AS max_stock_level, CONVERT(decimal(18, 1), inv.reorder_qty) AS reorder_qty, 
				trn.serial_number, category.description AS category 
			FROM inventory_transactions trn 
			INNER JOIN inventory inv ON trn.inventory_id = inv.inventory_id 
			INNER JOIN item ON inv.item_id = item.item_id 
			INNER JOIN location ON inv.location_id = location.location_id AND location.record_status = 1
			INNER JOIN sites ON location.site_id = sites.site_id AND sites.site_id <> 0 
			INNER JOIN customer ON trn.customer_id = customer.customer_id 
			INNER JOIN category ON item.category_id = category.category_id 
			WHERE trn.record_status = 1 
			AND item.record_status = 1 
			AND trn.company_id = 1 
			AND trn.trans_type IN (150, 250, 450, 100, 200, 400, 500 ) 
			AND (trn.date_code > '' and trn.date_code < replace(convert(varchar, getdate(), 102), '.', ''))
			GROUP BY inv.min_stock_level, inv.max_stock_level, inv.reorder_qty, trn.pallet, trn.lot, trn.po, trn.date_code, 
				trn.serial_number, item.item_id, item.item_number, item.description,sites.site_name, 
				location.code, category.[description]
		end
		else
		begin
			SELECT item.item_id AS rec_id, item.item_number, 
				item.description AS item_desc, sites.site_name, location.code, 
				CONVERT(decimal(18, 1), SUM(trn.remaining_qty)) AS quantity, MIN(trn.date_acquired) AS oldest, MAX(trn.date_acquired) AS newest, 
				trn.pallet, trn.lot, trn.po, trn.date_code,
				CONVERT(decimal(18, 1), inv.min_stock_level) AS min_stock_level,
				CONVERT(decimal(18, 1), inv.max_stock_level) AS max_stock_level, CONVERT(decimal(18, 1), inv.reorder_qty) AS reorder_qty, 
				trn.serial_number, category.description AS category 
			FROM inventory_transactions trn 
			INNER JOIN inventory inv ON trn.inventory_id = inv.inventory_id 
			INNER JOIN item ON inv.item_id = item.item_id 
			INNER JOIN location ON inv.location_id = location.location_id AND location.record_status = 1
			INNER JOIN sites ON location.site_id = sites.site_id AND sites.site_id <> 0 
			INNER JOIN customer ON trn.customer_id = customer.customer_id 
			INNER JOIN category ON item.category_id = category.category_id 
			WHERE trn.record_status = 1 
			AND item.record_status = 1 
			AND trn.company_id = 1 
			AND trn.trans_type IN (150, 250, 450, 100, 200, 400, 500 ) 
			AND (trn.date_code > '' and trn.date_code < replace(convert(varchar, getdate(), 102), '.', ''))
			AND trn.location_id in (SELECT loc.location_id FROM location loc where loc.site_id in (select site_id from user_site where user_id = @nUserID))
			GROUP BY inv.min_stock_level, inv.max_stock_level, inv.reorder_qty, trn.pallet, trn.lot, trn.po, trn.date_code, 
				trn.serial_number, item.item_id, item.item_number, item.description,sites.site_name, 
				location.code, category.[description]		end
	end
END 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/****** Object:  StoredProcedure [dbo].[SpAlertItemPastDue]    Script Date: 02/13/2013 08:31:18 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO



/****** Object:  StoredProcedure [dbo].[SpAlertItemPastDue]    Script Date: 02/04/2013 15:04:12 ******/
CREATE PROCEDURE [SpAlertItemPastDue] @nUserID int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    	declare @nNumberOfSite int
	set @nNumberOfSite = 0

	select @nNumberOfSite = count(*) from user_site where user_id = @nUserID

	if( @nNumberOfSite > 0 )
	begin
		declare @nSiteID int
		set @nSiteID = 0

		-- if user has privilege on only one site, check to see if site_id is 0
		if( @nNumberOfSite = 1 )
		begin
			select @nSiteID = site_id from user_site where user_id = @nUserID
		end
		
		-- if site id is 0, user @nUserID can access to all sites
		if( @nSiteID = 0 )
		begin
			SELECT t.trans_date, i.item_number, i.[description], CONVERT(DECIMAL(18, 1), CASE trans_type  WHEN 450 THEN t.current_qty 
			ELSE t.quantity END) AS quantity, t.entry_date, CASE trans_type WHEN 350 THEN NULL  else case t.date_acquired WHEN '1800-01-01' THEN NULL 
			ELSE t.date_acquired END END AS date_acquired, CASE trans_type WHEN 350 THEN CASE t.date_acquired WHEN '1800-01-01' THEN NULL ELSE t.date_acquired END 
			ELSE NULL END AS due_date, t.serial_number, t.date_code, t.pallet, t.lot, cr.customer_number AS customer_number_trn, cr.name as customer_name
			FROM inventory_transactions t, item i, customer cr
			WHERE t.record_status = 1 
			AND t.company_id = 1 
			AND t.trans_type = 350 
			AND t.item_id = i.item_id 
			AND t.customer_id = cr.customer_id 
			AND t.date_acquired < GETDATE() 
			AND t.date_acquired > ''
		end
		else
		begin
			SELECT t.trans_date, i.item_number, i.[description], CONVERT(DECIMAL(18, 1), CASE trans_type  WHEN 450 THEN t.current_qty 
			ELSE t.quantity END) AS quantity, t.entry_date, CASE trans_type WHEN 350 THEN NULL  else case t.date_acquired WHEN '1800-01-01' THEN NULL 
			ELSE t.date_acquired END END AS date_acquired, CASE trans_type WHEN 350 THEN CASE t.date_acquired WHEN '1800-01-01' THEN NULL ELSE t.date_acquired END 
			ELSE NULL END AS due_date, t.serial_number, t.date_code, t.pallet, t.lot, cr.customer_number AS customer_number_trn, cr.name as customer_name
			FROM inventory_transactions t, item i, customer cr
			WHERE t.record_status = 1 
			AND t.company_id = 1
			AND t.trans_type = 350 
			AND t.item_id = i.item_id 
			AND t.customer_id = cr.customer_id 
			AND t.date_acquired < GETDATE() 
			AND t.date_acquired > ''
			AND t.location_id in (SELECT loc.location_id FROM location loc where loc.site_id in (select site_id from user_site where user_id = @nUserID))
		end
	end
END
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

/****** Object:  StoredProcedure [dbo].[SpCustomerInfoExt]    Script Date: 08/29/2013 10:56:34 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


CREATE PROCEDURE [dbo].[SpCustomerInfoExt]

AS
BEGIN

SET NOCOUNT ON

SELECT     
customer_id, 
customer_number, 
dbo.customer.name, 
company_name, 
email, 
department, 
date_added, 
record_status,
company_id

into #t1
FROM         dbo.customer

select  Customer_id, phone_number, extension
into #t2
FROM         dbo.Customer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Customer.Customer_id AND dbo.phone.table_name = 'Customer' and dbo.phone.phone_type_id=1

select  Customer_id,phone_number as 'Fax'
into #t3
FROM         dbo.Customer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Customer.Customer_id AND dbo.phone.table_name = 'Customer' and dbo.phone.phone_type_id=3

select Customer_id,phone_number as 'hPhone' 
into #t4
FROM         dbo.Customer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Customer.Customer_id AND dbo.phone.table_name = 'Customer' and dbo.phone.phone_type_id=4

select Customer_id,phone_number as 'cCell' 
into #t5
FROM         dbo.Customer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Customer.Customer_id AND  dbo.phone.table_name = 'Customer' and dbo.phone.phone_type_id=2

SELECT dbo.customer.customer_id,dbo.sales_tax_code.tax_code as 'tax_code'                      
into #t6
FROM dbo.Customer LEFT OUTER JOIN 
		dbo.customer_ext ON dbo.customer_ext.customer_id = dbo.customer.customer_id LEFT OUTER JOIN
		dbo.sales_tax_code ON dbo.sales_tax_code.tax_code_id = dbo.customer_ext.sales_tax_code_id

--get notes related to the customers
create   table #t7 ( 
other_id int,
table_name varchar(50) null,
note_text varchar(7000) null)

DECLARE @otherid int,
@lastid int,
@lastname varchar(50),
@tablename varchar(50),
@notetext varchar(1000),
@notedate varchar(20),
@output varchar(7000),
@err int

 
select distinct other_id, table_name
into #t8
from vNotes
where table_name = 'customer'
 
DECLARE id_cur CURSOR  FOR
SELECT other_id, table_name FROM #t8 ORDER BY other_id

open id_cur

--//Id cursor
while 1=1
begin
	FETCH id_cur INTO @lastid, @lastname
	if (@@fetch_status<>0) break
 	set @output = ''

	DECLARE note_cur CURSOR  FOR
	SELECT other_id, table_name, note_text, note_date FROM vNotes 
	WHERE  other_id = @lastid and table_name = @lastname
	ORDER BY other_id

	OPEN note_cur
	WHILE 1= 1
	
	BEGIN
		FETCH note_cur INTO @otherid, @tablename, @notetext, @notedate
	 	if (@@fetch_status<>0) break
	
		if( rtrim(ltrim(isnull(@notetext, ''))) != '' )
			set @output =  @output + @notetext + char(32) +  char(40) + @notedate  + char(41) + char(13)
	END
	CLOSE note_cur
	DEALLOCATE note_cur

	if( rtrim(ltrim(isnull(@output, ''))) != '' )
		INSERT #t7 (other_id, table_name, note_text)   VALUES (@lastid, @lastname, @output)
end --id_cur

CLOSE id_cur
DEALLOCATE id_cur

 

SELECT     
#t1.Customer_id, 
#t1.customer_number,
#t1.name, 
company_name, 
email, 
department, 
date_added, 
#t1.record_status,
#t1.company_id,
phone_number, 
extension,
fax,
hphone,
ccell,
tax_code,
note_text,
address1,
address2,
city,
[state],
postal_code,
country

from #t1 inner join #t2 on #t1.Customer_id = #t2.Customer_id
inner join #t3 on #t3.Customer_id = #t2.Customer_id
inner join #t4 on #t4.Customer_id = #t2.Customer_id
inner join #t5 on #t5.Customer_id = #t2.Customer_id
inner join #t6 on #t6.customer_id = #t2.customer_id
left outer join #t7 on #t7.other_id = #t1.Customer_id
left outer join vCustomerBillingAddress on vCustomerBillingAddress.customer_id = #t1.Customer_id
where #t1.Customer_id >0

drop table #t1
drop table #t2
drop table #t3
drop table #t4
drop table #t5
drop table #t6
drop table #t7
drop table #t8

END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[SpSaveGridSettings]
	@SQL NTEXT
AS
BEGIN
	SET NOCOUNT ON;
	DECLARE @intErrorCode INT
	
	BEGIN TRAN
		EXEC (@SQL)
		
		SELECT @intErrorCode = @@ERROR
		IF (@intErrorCode <> 0) GOTO PROBLEM
	COMMIT TRAN
	
	PROBLEM:
	IF (@intErrorCode <> 0)
		RAISERROR('Encountered error number: %u',10,1,@@ERROR) 
END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO