USE [WaspTrackInventory]
GO

PRINT ''
PRINT ''
PRINT '******************************'
PRINT 'Update Triggers               '
PRINT '******************************'
PRINT ''


if EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[trSiteDeleted]') AND OBJECTPROPERTY(id, N'IsTrigger') = 1)
DROP TRIGGER [dbo].[trSiteDeleted]
GO

if EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[trUserDeleted]') AND OBJECTPROPERTY(id, N'IsTrigger') = 1)
DROP TRIGGER [dbo].[trUserDeleted]
GO

/****** Object:  Trigger [trCustomerLastUpdate]    Script Date: 04/21/2011 13:15:58 ******/
if EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[trCustomerLastUpdate]') AND OBJECTPROPERTY(id, N'IsTrigger') = 1)
DROP TRIGGER [dbo].[trCustomerLastUpdate]
GO

if EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[trSupplierLastUpdate]') AND OBJECTPROPERTY(id, N'IsTrigger') = 1)
DROP TRIGGER [dbo].[trSupplierLastUpdate]
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[trDateUpdated]') AND OBJECTPROPERTY(id, N'IsTrigger') = 1)
DROP TRIGGER [dbo].[trDateUpdated]

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[tr_update_po_master_last_update]') AND OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[tr_update_po_master_last_update]
go

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[tr_update_pick_order_last_update]') AND OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[tr_update_pick_order_last_update]
go

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[trSalesTaxCodeLastModifiedDate]') AND OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[trSalesTaxCodeLastModifiedDate]
go

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[trLastModifiedDate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
DROP TRIGGER [dbo].[trLastModifiedDate]
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[trCompositionLastUpdatedDate]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
DROP TRIGGER [dbo].[trCompositionLastUpdatedDate]
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[trUpdateItemSupplierId]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
DROP TRIGGER [dbo].[trUpdateItemSupplierId]
GO
--------------------------------------------
--
-- Now create new triggers
--
--------------------------------------------

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE TRIGGER [trSiteDeleted] ON [dbo].[sites] FOR DELETE
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    delete from user_default_working_site where site_id in ( select site_id from deleted )

END
GO


SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE TRIGGER [trUserDeleted] ON [dbo].[users] FOR DELETE
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    delete from user_default_working_site where user_id in ( select user_id from deleted )

END
GO


SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER OFF
GO

CREATE TRIGGER [dbo].[trCustomerLastUpdate] ON [dbo].[customer] 
FOR INSERT, UPDATE 
AS
	update customer set last_modified_date = getdate() where customer_id in (select customer_id from inserted)
GO


SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO


CREATE TRIGGER [dbo].[trSupplierLastUpdate] ON [dbo].supplier 
FOR INSERT, UPDATE 
AS
	update supplier set last_modified_date = getdate() where supplier_id in (select supplier_id from inserted)
GO


SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO


CREATE TRIGGER [dbo].[trDateUpdated] ON [dbo].[item] 
FOR INSERT, UPDATE 
AS
	update item set date_updated = getdate() where item_id in (select item_id from inserted)

GO


SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE trigger [dbo].[tr_update_po_master_last_update]
on [dbo].[po_detail]
after insert, update, delete as

update po_master set last_modified_date = getdate() where po_master.po_id in (select po_id from inserted
  union
  select po_id from deleted)

GO


SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create trigger [dbo].[tr_update_pick_order_last_update]
on [dbo].[pick_order_detail]
after insert, update, delete as


update pick_order set last_modified_date = getdate() where pick_order.pick_order_id in (select pick_order_id from inserted
  union
  select pick_order_id from deleted)
GO


SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TRIGGER [dbo].[trSalesTaxCodeLastModifiedDate] ON [dbo].[sales_tax_code] 
FOR INSERT, UPDATE 
AS
	UPDATE sales_tax_code set last_modified_date = GETDATE() WHERE tax_code_id IN (SELECT tax_code_id FROM inserted)

GO

-- ================================================
-- This trigger updates the last modified date
-- ================================================
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		Jeff Schmeling
-- Create date: 
-- Description:	
-- =============================================
CREATE TRIGGER trLastModifiedDate 
   ON  po_master 
   AFTER INSERT,UPDATE
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    update po_master set last_modified_date = getdate() where po_id in (select po_id from inserted)

END
GO

-- =============================================
-- Author:		Christina Ye	
-- Create date: 6/16/2008
-- Description:	Update the supplier info on item record
-- =============================================
CREATE TRIGGER [dbo].[trUpdateItemSupplierId]
   ON  [dbo].[item_supplier]
   FOR INSERT,DELETE,UPDATE
AS 
BEGIN
	IF (SELECT COUNT(supplier_id) from [item_supplier] 
						WHERE default_supplier = 'T' AND
							  item_id in (SELECT item_id FROM  inserted)) <> 1
	BEGIN
		UPDATE item 
			SET supplier_id =  0
			WHERE item_id in (SELECT item_id from [item_supplier] 
							WHERE item_id in (SELECT item_id FROM  inserted))
	END
	ELSE
	BEGIN
		UPDATE item 
		SET supplier_id =  
			(SELECT supplier_id from [item_supplier] 
							WHERE default_supplier = 'T' AND
								  item_id in (SELECT item_id FROM  inserted))
		WHERE item_id in (SELECT item_id from [item_supplier] 
							WHERE default_supplier = 'T' AND
								  item_id in (SELECT item_id FROM  inserted))
	END

END