USE [WaspTrackInventory]
GO



print '----------------------------------------'
print '--                                      '
print '--  CREATE PRIMARY KEYS/INDEXES SECTION '
print '--                                      '
print '----------------------------------------'



IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[audit_transactions]') AND name = N'PK_audit_transactions')
BEGIN
ALTER TABLE [dbo].[audit_transactions] WITH NOCHECK ADD 
	CONSTRAINT [PK_audit_transactions] PRIMARY KEY  CLUSTERED 
	(
		[transaction_id]
	)  ON [PRIMARY] 
END	
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[auto_numbers]') AND name = N'PK_auto_numbers')
BEGIN
ALTER TABLE [dbo].[auto_numbers] WITH NOCHECK ADD 
	CONSTRAINT [PK_auto_numbers] PRIMARY KEY  CLUSTERED 
	(
		[object_type],
		[company_id]
	)  ON [PRIMARY] 
END	
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[attachments]') AND name = N'PK_attachments')
BEGIN
ALTER TABLE [dbo].[attachments] WITH NOCHECK ADD
	CONSTRAINT [PK_attachments] PRIMARY KEY  CLUSTERED 
		(
			[attach_id],
			[attach_type],
			[file_name]
		)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[category]') AND name = N'PK_category')
BEGIN
ALTER TABLE [dbo].[category] WITH NOCHECK ADD 
	CONSTRAINT [PK_category] PRIMARY KEY  CLUSTERED 
	(
		[category_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[company_info]') AND name = N'PK_companyinfo')
BEGIN
ALTER TABLE [dbo].[company_info] WITH NOCHECK ADD 
	CONSTRAINT [PK_companyinfo] PRIMARY KEY  CLUSTERED 
	(
		[company_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[customer]') AND name = N'PK_customer')
BEGIN
ALTER TABLE [dbo].[customer] WITH NOCHECK ADD 
	CONSTRAINT [PK_customer] PRIMARY KEY  CLUSTERED 
	(
		[customer_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[find_meta]') AND name = N'PK_find_meta')
BEGIN
ALTER TABLE [dbo].[find_meta] WITH NOCHECK ADD 
	CONSTRAINT [PK_find_meta] PRIMARY KEY  CLUSTERED 
	(
		[rec_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[form]') AND name = N'PK_form')
BEGIN
ALTER TABLE [dbo].[form] WITH NOCHECK ADD 
	CONSTRAINT [PK_form] PRIMARY KEY  CLUSTERED 
	(
		[form_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[form_field_meta]') AND name = N'PK_form_field_meta')
BEGIN
ALTER TABLE [dbo].[form_field_meta] WITH NOCHECK ADD 
	CONSTRAINT [PK_form_field_meta] PRIMARY KEY  CLUSTERED 
	(
		[form_id],
		[field]
	)  ON [PRIMARY] 
END
GO



IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[image]') AND name = N'PK_image')
BEGIN
ALTER TABLE [dbo].[image] WITH NOCHECK ADD 
	CONSTRAINT [PK_image] PRIMARY KEY  CLUSTERED 
	(
		[image_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[import_export_errors]') AND name = N'PK_import_export_errors')
BEGIN
ALTER TABLE [dbo].[import_export_errors] WITH NOCHECK ADD 
	CONSTRAINT [PK_import_export_errors] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[inv_audit]') AND name = N'PK_inv_audit')
BEGIN
ALTER TABLE [dbo].[inv_audit] WITH NOCHECK ADD 
	CONSTRAINT [PK_inv_audit] PRIMARY KEY  CLUSTERED 
	(
		[site],
		[start_date]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[inventory]') AND name = N'PK_inventory')
BEGIN
ALTER TABLE [dbo].[inventory] WITH NOCHECK ADD 
	CONSTRAINT [PK_inventory] PRIMARY KEY  CLUSTERED 
	(
		[inventory_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[inventory_request_detail]') AND name = N'PK_inventory_request_detail')
BEGIN
ALTER TABLE [dbo].[inventory_request_detail] WITH NOCHECK ADD 
	CONSTRAINT [PK_inventory_request_detail] PRIMARY KEY  CLUSTERED 
	(
		[inventory_request_line_item_id],
		[site],
		[location]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[inventory_request_manual_line]') AND name = N'PK_inventory_request_manual_line')
BEGIN
ALTER TABLE [dbo].[inventory_request_manual_line] WITH NOCHECK ADD 
	CONSTRAINT [PK_inventory_request_manual_line] PRIMARY KEY  CLUSTERED 
	(
		[manual_line_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[inventory_transactions]') AND name = N'PK_inventory_transations')
BEGIN
ALTER TABLE [dbo].[inventory_transactions] WITH NOCHECK ADD 
	CONSTRAINT [PK_inventory_transations] PRIMARY KEY  CLUSTERED 
	(
		[transaction_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[invoice_line_items]') AND name = N'PK_invoice_line_items')
BEGIN
ALTER TABLE [dbo].[invoice_line_items] WITH NOCHECK ADD 
	CONSTRAINT [PK_invoice_line_items] PRIMARY KEY  CLUSTERED 
	(
		[line_item_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[invoice_line_items_archive]') AND name = N'PK_invoice_line_items_archive')
BEGIN
ALTER TABLE [dbo].[invoice_line_items_archive] WITH NOCHECK ADD 
	CONSTRAINT [PK_invoice_line_items_archive] PRIMARY KEY  CLUSTERED 
	(
		[line_item_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[invoice_master]') AND name = N'PK_invoice_master')
BEGIN
ALTER TABLE [dbo].[invoice_master] WITH NOCHECK ADD 
	CONSTRAINT [PK_invoice_master] PRIMARY KEY  CLUSTERED 
	(
		[invoice_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[invoice_master_archive]') AND name = N'PK_invoice_master_archive')
BEGIN
ALTER TABLE [dbo].[invoice_master_archive] WITH NOCHECK ADD 
	CONSTRAINT [PK_invoice_master_archive] PRIMARY KEY  CLUSTERED 
	(
		[invoice_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[item]') AND name = N'PK_item')
	BEGIN
		ALTER TABLE [dbo].[item] WITH NOCHECK ADD 
		CONSTRAINT [PK_item] PRIMARY KEY  CLUSTERED 
		(
			[item_id] ASC
		) ON [PRIMARY]
	END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[item_receipt]') AND name = N'PK_item_receipt')
BEGIN
ALTER TABLE [dbo].[item_receipt] WITH NOCHECK ADD 
	CONSTRAINT [PK_item_receipt] PRIMARY KEY  CLUSTERED 
	(
		[item_receipt_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[item_supplier]') AND name = N'PK_item_supplier')
BEGIN
ALTER TABLE [dbo].[item_supplier] WITH NOCHECK ADD 
	CONSTRAINT [PK_item_supplier] PRIMARY KEY  CLUSTERED 
	(
		[item_supplier_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[location]') AND name = N'PK_location')
BEGIN
ALTER TABLE [dbo].[location] WITH NOCHECK ADD 
	CONSTRAINT [PK_location] PRIMARY KEY  CLUSTERED 
	(
		[location_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[manufacturer]') AND name = N'PK_manufacturer')
BEGIN
ALTER TABLE [dbo].[manufacturer] WITH NOCHECK ADD 
	CONSTRAINT [PK_manufacturer] PRIMARY KEY  CLUSTERED 
	(
		[manufacturer_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[number_template]') AND name = N'PK_number_template')
BEGIN
ALTER TABLE [dbo].[number_template] WITH NOCHECK ADD 
	CONSTRAINT [PK_number_template] PRIMARY KEY  CLUSTERED 
	(
		[format_name],
		[f_order_no]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[pay_methods]') AND name = N'PK_pay_methods')
BEGIN
ALTER TABLE [dbo].[pay_methods] WITH NOCHECK ADD 
	CONSTRAINT [PK_pay_methods] PRIMARY KEY  CLUSTERED 
	(
		[pay_method_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[pick_order]') AND name = N'PK_pick_order')
BEGIN
ALTER TABLE [dbo].[pick_order] WITH NOCHECK ADD 
	CONSTRAINT [PK_pick_order] PRIMARY KEY  CLUSTERED 
	(
		[pick_order_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[pick_order_detail]') AND name = N'PK_pick_order_detail')
BEGIN
ALTER TABLE [dbo].[pick_order_detail] WITH NOCHECK ADD 
	CONSTRAINT [PK_pick_order_detail] PRIMARY KEY  CLUSTERED 
	(
		[pick_order_detail_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[po_detail]') AND name = N'PK_po_detail')
BEGIN
ALTER TABLE [dbo].[po_detail] WITH NOCHECK ADD 
	CONSTRAINT [PK_po_detail] PRIMARY KEY  CLUSTERED 
	(
		[po_detail_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[po_invoice_status]') AND name = N'PK_po_invoice_status')
BEGIN
ALTER TABLE [dbo].[po_invoice_status] WITH NOCHECK ADD 
	CONSTRAINT [PK_po_invoice_status] PRIMARY KEY  CLUSTERED 
	(
		[status_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[po_master]') AND name = N'PK_po_master')
BEGIN
ALTER TABLE [dbo].[po_master] WITH NOCHECK ADD 
	CONSTRAINT [PK_po_master] PRIMARY KEY  CLUSTERED 
	(
		[po_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[reasons_adjustment]') AND name = N'PK_reasons_adjustment')
BEGIN
ALTER TABLE [dbo].[reasons_adjustment] WITH NOCHECK ADD 
	CONSTRAINT [PK_reasons_adjustment] PRIMARY KEY  CLUSTERED 
	(
		[reason_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[recent_values]') AND name = N'PK_recent_values')
BEGIN
ALTER TABLE [dbo].[recent_values] WITH NOCHECK ADD 
	CONSTRAINT [PK_recent_values] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[security_privileges]') AND name = N'PK_security_privileges')
BEGIN
ALTER TABLE [dbo].[security_privileges] WITH NOCHECK ADD 
	CONSTRAINT [PK_security_privileges] PRIMARY KEY  CLUSTERED 
	(
		[security_code]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[ship_methods]') AND name = N'PK_ship_methods')
BEGIN
ALTER TABLE [dbo].[ship_methods] WITH NOCHECK ADD 
	CONSTRAINT [PK_ship_methods] PRIMARY KEY  CLUSTERED 
	(
		[ship_method_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[sites]') AND name = N'PK_sites')
BEGIN
ALTER TABLE [dbo].[sites] WITH NOCHECK ADD 
	CONSTRAINT [PK_sites] PRIMARY KEY  CLUSTERED 
	(
		[site_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[supplier]') AND name = N'PK_supplier')
BEGIN
ALTER TABLE [dbo].[supplier] WITH NOCHECK ADD 
	CONSTRAINT [PK_supplier] PRIMARY KEY  CLUSTERED 
	(
		[supplier_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[transfer_field_mapping]') AND name = N'PK_transfer_field_mapping')
BEGIN
ALTER TABLE [dbo].[transfer_field_mapping] WITH NOCHECK ADD 
	CONSTRAINT [PK_transfer_field_mapping] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[transfer_map]') AND name = N'PK_transfer_map')
BEGIN
ALTER TABLE [dbo].[transfer_map] WITH NOCHECK ADD 
	CONSTRAINT [PK_transfer_map] PRIMARY KEY  CLUSTERED 
	(
		[map_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[unit_of_measure]') AND name = N'PK_unit_of_measure')
BEGIN
ALTER TABLE [dbo].[unit_of_measure] WITH NOCHECK ADD 
	CONSTRAINT [PK_unit_of_measure] PRIMARY KEY  CLUSTERED 
	(
		[uom_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[user_privileges]') AND name = N'PK_employee_privileges')
BEGIN
ALTER TABLE [dbo].[user_privileges] WITH NOCHECK ADD 
	CONSTRAINT [PK_employee_privileges] PRIMARY KEY  CLUSTERED 
	(
		[user_id],
		[security_code]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[users]') AND name = N'PK_USER_UD')
BEGIN
ALTER TABLE [dbo].[users] WITH NOCHECK ADD 
	CONSTRAINT [PK_USER_UD] PRIMARY KEY  CLUSTERED 
	(
		[user_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[users_mobile]') AND name = N'PK_users_mobile')
BEGIN
ALTER TABLE [dbo].[users_mobile] WITH NOCHECK ADD 
	CONSTRAINT [PK_users_mobile] PRIMARY KEY  CLUSTERED 
	(
		[type],
		[name]
	)  ON [PRIMARY] 
END
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'DF_audit_transactions_other_id') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
ALTER TABLE [dbo].[audit_transactions] ADD 
	CONSTRAINT [DF_audit_transactions_other_id] DEFAULT (0) FOR [other_id]
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'DF_audit_transactions_entry_date') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
ALTER TABLE [dbo].[audit_transactions] ADD 
	CONSTRAINT [DF_audit_transactions_entry_date] DEFAULT (getdate()) FOR [entry_date]
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'DF_audit_transactions_customer_id') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
ALTER TABLE [dbo].[audit_transactions] ADD 
	CONSTRAINT [DF_audit_transactions_customer_id] DEFAULT (0) FOR [customer_id]
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'DF_audit_transactions_supplier_id') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
ALTER TABLE [dbo].[audit_transactions] ADD 
	CONSTRAINT [DF_audit_transactions_supplier_id] DEFAULT (0) FOR [supplier_id]
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'DF_audit_transactions_po_id') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
ALTER TABLE [dbo].[audit_transactions] ADD 
	CONSTRAINT [DF_audit_transactions_po_id] DEFAULT (0) FOR [po_id]
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'DF_audit_transactions_invoice_id') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
ALTER TABLE [dbo].[audit_transactions] ADD 
	CONSTRAINT [DF_audit_transactions_invoice_id] DEFAULT (0) FOR [invoice_id]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_AUDIT_TRAN_ITEM_ID'))
 CREATE  INDEX [IX_AUDIT_TRAN_ITEM_ID] ON [dbo].[audit_transactions]([item_id]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_AUDIT_TRAN_LOCATION'))
 CREATE  INDEX [IX_AUDIT_TRAN_LOCATION] ON [dbo].[audit_transactions]([location_id]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'DF_auto_numbers_netxt_id') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
ALTER TABLE [dbo].[auto_numbers] ADD 
	CONSTRAINT [DF_auto_numbers_netxt_id] DEFAULT (0) FOR [next_id]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_customer_list_id'))
 CREATE  INDEX [IX_customer_list_id] ON [dbo].[customer]([list_id]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'DF_form_field_meta_user_editable') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[form_field_meta] ADD 
	CONSTRAINT [DF_form_field_meta_user_editable] DEFAULT ('T') FOR [user_editable],
	CONSTRAINT [DF_form_field_meta_should_find_1] DEFAULT ('T') FOR [should_find],
	CONSTRAINT [DF_form_field_meta_should_export_1] DEFAULT (1) FOR [should_export],
	CONSTRAINT [DF_form_field_meta_should_import_1] DEFAULT (1) FOR [should_import]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'DF_history_transactions_po_id') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[history_transactions] ADD 
	CONSTRAINT [DF_history_transactions_po_id] DEFAULT (0) FOR [po_id],
	CONSTRAINT [DF_history_transactions_invoice_id] DEFAULT (0) FOR [invoice_id],
	CONSTRAINT [DF_history_transactions_print_label_no] DEFAULT (0) FOR [print_label_no]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_history_TRAN_ITEM_ID'))
 CREATE  INDEX [IX_history_TRAN_ITEM_ID] ON [dbo].[history_transactions]([item_id]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_history_TRAN_LOCATION'))
 CREATE  INDEX [IX_history_TRAN_LOCATION] ON [dbo].[history_transactions]([location_id]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE NAME like 'DF__inventory__max_s%' OR NAME like 'DF_inventory_max_s%')
BEGIN
ALTER TABLE [dbo].[inventory] ADD 
	CONSTRAINT [DF_inventory_max_stock_level] DEFAULT (0) FOR [max_stock_level]
END
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE NAME like 'DF__inventory__min_s%' OR NAME like 'DF_inventory_min_s%')
BEGIN
ALTER TABLE [dbo].[inventory] ADD 
	CONSTRAINT [DF_inventory_min_stock_level] DEFAULT (0) FOR [min_stock_level]
END
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE NAME like 'DF__inventory__reord%' OR NAME like 'DF_inventory_reord%')
BEGIN
ALTER TABLE [dbo].[inventory] ADD 
	CONSTRAINT [DF_inventory_reorder_qty] DEFAULT (0) FOR [reorder_qty]
END
GO


IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[inventory]') AND name = N'IX_inventory')
BEGIN
ALTER TABLE [dbo].[inventory] ADD 
	CONSTRAINT [IX_inventory] UNIQUE  NONCLUSTERED 
	(
		[item_id],
		[location_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_inventory_primary_location') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
ALTER TABLE [dbo].[inventory] ADD CONSTRAINT [DF_inventory_primary_location] DEFAULT ('F') FOR [primary_location]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_inventory_lsform_only') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
ALTER TABLE [dbo].[inventory] ADD CONSTRAINT [DF_inventory_lsform_only] DEFAULT ('F') FOR [lsgrid_only]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_inventory_request_is_canceled') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[inventory_request] ADD 
	CONSTRAINT [DF_inventory_request_is_canceled] DEFAULT ('F') FOR [is_canceled],
	CONSTRAINT [DF_inventory_request_print_no] DEFAULT (0) FOR [print_no]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_inventory_request_detail_is_selected') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[inventory_request_detail] ADD 
	CONSTRAINT [DF_inventory_request_detail_is_selected] DEFAULT ('F') FOR [is_selected]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_inventory_request_manual_line_cost') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[inventory_request_manual_line] ADD 
	CONSTRAINT [DF_inventory_request_manual_line_cost] DEFAULT (0) FOR [cost],
	CONSTRAINT [DF_inventory_request_manual_line_quantity] DEFAULT (0) FOR [quantity]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE NAME like 'DF__inventory__invoi%' OR NAME like 'DF_inventory_transactions_invoice_id%')
BEGIN
ALTER TABLE [dbo].[inventory_transactions] ADD 
	CONSTRAINT [DF_inventory_transactions_invoice_id] DEFAULT (0) FOR [invoice_id]
END
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE NAME like 'DF__inventory__po_id%' OR name LIKE 'DF_inventory_transactions_po_id%')
BEGIN
ALTER TABLE [dbo].[inventory_transactions] ADD 
	CONSTRAINT [DF_inventory_transactions_po_id] DEFAULT (0) FOR [po_id]
END
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_inventory_transactions_trans_action') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[inventory_transactions] ADD 
	CONSTRAINT [DF_inventory_transactions_trans_action] DEFAULT (0) FOR [action_type],
	CONSTRAINT [DF_inventory_transactions_entry_date] DEFAULT (getdate()) FOR [entry_date],
	CONSTRAINT [DF_inventory_transactions_current_qty] DEFAULT (0) FOR [current_qty],
	CONSTRAINT [DF_inventory_transactions_other_id] DEFAULT (0) FOR [other_id],
	CONSTRAINT [DF_inventory_transactions_customer_id] DEFAULT (0) FOR [customer_id],
	CONSTRAINT [DF_inventory_transactions_supplier_id] DEFAULT (0) FOR [supplier_id],
	CONSTRAINT [DF_inventory_transactions_print_label_no] DEFAULT (0) FOR [print_label_no]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_inventory_transactions_is_receive_or_ship') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
ALTER TABLE [dbo].[inventory_transactions] ADD CONSTRAINT [DF_inventory_transactions_is_receive_or_ship] DEFAULT ('F') FOR [is_receive_or_ship]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_TRAN_ITEM_ID'))
 CREATE  INDEX [IX_TRAN_ITEM_ID] ON [dbo].[inventory_transactions]([item_id]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_TRAN_LOCATION'))
 CREATE  INDEX [IX_TRAN_LOCATION] ON [dbo].[inventory_transactions]([location_id]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_TRANS_PO'))
 CREATE  INDEX [IX_TRANS_PO] ON [dbo].[inventory_transactions]([po]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_TRANS_INVOICE_ID'))
 CREATE  INDEX [IX_TRANS_INVOICE_ID] ON [dbo].[inventory_transactions]([invoice_id]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_invoice_line_items_picked_quantity') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[invoice_line_items] ADD 
	CONSTRAINT [DF_invoice_line_items_picked_quantity] DEFAULT (0) FOR [picked_quantity],
	CONSTRAINT [DF_invoice_line_items_amount] DEFAULT (0) FOR [amount]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_invoice_line_items_archive_picked_quantity') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[invoice_line_items_archive] ADD 
	CONSTRAINT [DF_invoice_line_items_archive_picked_quantity] DEFAULT (0) FOR [picked_quantity],
	CONSTRAINT [DF_invoice_line_items_archive_amount] DEFAULT (0) FOR [amount]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_invoice_line_items_archive_invoice_Id'))
 CREATE  INDEX [IX_invoice_line_items_archive_invoice_Id] ON [dbo].[invoice_line_items_archive]([invoice_id]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_invoice_master_invoice_status') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[invoice_master] ADD 
	CONSTRAINT [DF_invoice_master_invoice_status] DEFAULT (1) FOR [invoice_status],
	CONSTRAINT [DF_invoice_master_line_item_count] DEFAULT (0) FOR [line_item_count],
	CONSTRAINT [DF_invoice_master_parent_id] DEFAULT (0) FOR [parent_id],
	CONSTRAINT [DF_invoice_master_backorder_id] DEFAULT (0) FOR [backorder_id],
	CONSTRAINT [DF_invoice_master_record_status_date] DEFAULT (getdate()) FOR [record_status_date]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_invoice_master_ref_number'))
 CREATE  INDEX [IX_invoice_master_ref_number] ON [dbo].[invoice_master]([ref_number]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_invoice_master_archive_invoice_status') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[invoice_master_archive] ADD 
	CONSTRAINT [DF_invoice_master_archive_invoice_status] DEFAULT (1) FOR [invoice_status],
	CONSTRAINT [DF_invoice_master_archive_line_item_count] DEFAULT (0) FOR [line_item_count],
	CONSTRAINT [DF_invoice_master_archive_parent_id] DEFAULT (0) FOR [parent_id],
	CONSTRAINT [DF_invoice_master_archive_backorder_id] DEFAULT (0) FOR [backorder_id]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE NAME = 'DF__item__default_lo__1E7A7156' OR NAME = 'DF_item_default_location_id')
BEGIN
ALTER TABLE [dbo].[item] ADD 
	CONSTRAINT [DF_item_default_location_id] DEFAULT (0) FOR [default_location_id]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE (name = 'DF_item_manufacturer_id'))
ALTER TABLE [dbo].[item] ADD 
	CONSTRAINT [DF_item_manufacturer_id] DEFAULT (0) FOR [manufacturer_id]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE (name = 'DF_item_category_id'))
ALTER TABLE [dbo].[item] ADD 
	CONSTRAINT [DF_item_category_id] DEFAULT (0) FOR [category_id]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE (name = 'DF_item_supplier_id'))
ALTER TABLE [dbo].[item] ADD 
	CONSTRAINT [DF_item_supplier_id] DEFAULT (0) FOR [supplier_id]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE (name = 'DF_item_qty_available'))
ALTER TABLE [dbo].[item] ADD 
	CONSTRAINT [DF_item_qty_available] DEFAULT (0) FOR [qty_available]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE (name = 'DF_item_qty_checked_out'))
ALTER TABLE [dbo].[item] ADD 
	CONSTRAINT [DF_item_qty_checked_out] DEFAULT (0) FOR [qty_checked_out]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE (name = 'DF_item_qty_in_house'))
ALTER TABLE [dbo].[item] ADD 
	CONSTRAINT [DF_item_qty_in_house] DEFAULT (0) FOR [qty_in_house]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE (name = 'DF_item_track_serial_numbers'))
ALTER TABLE [dbo].[item] ADD 
	CONSTRAINT [DF_item_track_serial_numbers] DEFAULT ('F') FOR [track_serial_numbers]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE (name = 'DF_item_track_lots'))
ALTER TABLE [dbo].[item] ADD 
	CONSTRAINT [DF_item_track_lots] DEFAULT ('F') FOR [track_lots]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE (name = 'DF_item_allow_fraction_qty'))
ALTER TABLE [dbo].[item] ADD 
	CONSTRAINT [DF_item_allow_fraction_qty] DEFAULT ('F') FOR [allow_fraction_qty]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE (name = 'DF_item_auto_sn'))
ALTER TABLE [dbo].[item] ADD 
	CONSTRAINT [DF_item_auto_sn] DEFAULT ('F') FOR [auto_sn]
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE (name = 'DF_item_auto_sn_value'))
ALTER TABLE [dbo].[item] ADD 
	CONSTRAINT [DF_item_auto_sn_value] DEFAULT (0) FOR [auto_sn_value]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_item_number'))
 CREATE  INDEX [IX_item_number] ON [dbo].[item]([item_number]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_desc'))
 CREATE  INDEX [IX_desc] ON [dbo].[item]([description]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_Item_ListId'))
 CREATE  INDEX [IX_Item_ListId] ON [dbo].[item]([list_id]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_item_receipt_date_received') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[item_receipt] ADD 
	CONSTRAINT [DF_item_receipt_date_received] DEFAULT (getdate()) FOR [date_received],
	CONSTRAINT [DF_item_receipt_quantity_received] DEFAULT (0) FOR [quantity_received],
	CONSTRAINT [DF_item_receipt_cost] DEFAULT (0) FOR [cost]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_item_supplier_default_supplier') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[item_supplier] ADD 
	CONSTRAINT [DF_item_supplier_default_supplier] DEFAULT ('F') FOR [default_supplier]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_item_supplier'))
 CREATE  INDEX [IX_item_supplier] ON [dbo].[item_supplier]([item_id], [supplier_id], [record_status], [company_id]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_Code_Site'))
 CREATE  INDEX [IX_Code_Site] ON [dbo].[location]([code], [site_id]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_notes_note_date') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[notes] ADD 
	CONSTRAINT [DF_notes_note_date] DEFAULT (getdate()) FOR [note_date],
	CONSTRAINT [DF_notes_note_user_id] DEFAULT (0) FOR [note_user_id]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_notes'))
 CREATE  INDEX [IX_notes] ON [dbo].[notes]([note_id], [table_name]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE (id = object_id(N'IX_pay_methods')))
ALTER TABLE [dbo].[pay_methods] ADD 
	CONSTRAINT [IX_pay_methods] UNIQUE  NONCLUSTERED 
	(
		[pay_method_text]
	)  ON [PRIMARY] 
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_pick_order_is_canceled') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[pick_order] ADD 
	CONSTRAINT [DF_pick_order_is_canceled] DEFAULT ('F') FOR [is_canceled],
	CONSTRAINT [DF_pick_order_print_no] DEFAULT (0) FOR [print_no]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_pick_order_number'))
 CREATE  INDEX [IX_pick_order_number] ON [dbo].[pick_order]([order_number]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_pick_order_detail_item_id') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[pick_order_detail] ADD 
	CONSTRAINT [DF_pick_order_detail_item_id] DEFAULT (0) FOR [item_id],
	CONSTRAINT [DF_pick_order_detail_request_quantity] DEFAULT (0) FOR [request_quantity],
	CONSTRAINT [DF_pick_order_detail_picked_quantity] DEFAULT (0) FOR [picked_quantity]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_po_detail_line_item_type') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[po_detail] ADD 
	CONSTRAINT [DF_po_detail_line_item_type] DEFAULT (1) FOR [line_item_type],
	CONSTRAINT [DF_po_detail_uom_id] DEFAULT (0) FOR [uom_id],
	CONSTRAINT [DF_po_detail_quantity] DEFAULT (0) FOR [quantity_ordered],
	CONSTRAINT [DF_po_detail_picked_quantity] DEFAULT (0) FOR [quantity_received],
	CONSTRAINT [DF_po_detail_quantity_original] DEFAULT (0) FOR [quantity_original]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE NAME = 'DF__po_master__po_st__1A75A19F' OR name ='DF_po_master_po_type')
BEGIN
ALTER TABLE [dbo].[po_master] ADD 
	CONSTRAINT [DF_po_master_po_type] DEFAULT ('PO') FOR [po_type]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE NAME = 'DF__po_master__po_ty__19817D66' OR name ='DF_po_master_po_status')
BEGIN
ALTER TABLE [dbo].[po_master] ADD 
	CONSTRAINT [DF_po_master_po_status] DEFAULT (1) FOR [po_status]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE NAME = 'DF__po_master__recor__1B69C5D8' OR name = 'DF_po_master_record_status_date')
BEGIN
ALTER TABLE [dbo].[po_master] ADD 
	CONSTRAINT [DF_po_master_record_status_date] DEFAULT (getdate()) FOR [record_status_date]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_reasons_adjustment_calculation_method') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[reasons_adjustment] ADD 
	CONSTRAINT [DF_reasons_adjustment_calculation_method] DEFAULT (1) FOR [calculation_method]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_recent_values_recent_date') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[recent_values] ADD 
	CONSTRAINT [DF_recent_values_recent_date] DEFAULT (getdate()) FOR [recent_date]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_recent_values'))
 CREATE  INDEX [IX_recent_values] ON [dbo].[recent_values]([form_id], [code]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_ship_methods_company_id') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[ship_methods] ADD 
	CONSTRAINT [DF_ship_methods_company_id] DEFAULT (1) FOR [company_id],
	CONSTRAINT [DF_ship_methods_record_status] DEFAULT (1) FOR [record_status]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_ship_methods'))
ALTER TABLE [dbo].[ship_methods] ADD 
	CONSTRAINT [IX_ship_methods] UNIQUE  NONCLUSTERED 
	(
		[ship_method_text]
	)  ON [PRIMARY] 
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_supplier_listid'))
 CREATE  INDEX [IX_supplier_listid] ON [dbo].[supplier]([list_id]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_unit_of_measure_quantity_eaches') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[unit_of_measure] ADD 
	CONSTRAINT [DF_unit_of_measure_quantity_eaches] DEFAULT (1) FOR [quantity_eaches],
	CONSTRAINT [DF_unit_of_measure_preferred_uom] DEFAULT ('F') FOR [preferred_uom],
	CONSTRAINT [DF_unit_of_measure_record_status] DEFAULT (1) FOR [record_status],
	CONSTRAINT [DF_unit_of_measure_company_id] DEFAULT (1) FOR [company_id]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_users_changed_password') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
ALTER TABLE [dbo].[users] ADD 
	CONSTRAINT [DF_users_changed_password] DEFAULT ('F') FOR [changed_password],
	CONSTRAINT [IX_USER_LOGON] UNIQUE  NONCLUSTERED 
	(
		[user_logon]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_account_categories_accnt_cat_description') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
BEGIN
	ALTER TABLE [dbo].[account_categories] ADD
		CONSTRAINT [DF_account_categories_accnt_cat_description] DEFAULT ('') FOR [accnt_cat_description]
END
GO


IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_USERS_LAST_NAME'))
 CREATE  INDEX [IX_USERS_LAST_NAME] ON [dbo].[users]([last_name]) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE (name = 'IX_USERS_FIRST_NAME'))
 CREATE  INDEX [IX_USERS_FIRST_NAME] ON [dbo].[users]([first_name]) ON [PRIMARY]
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_form_field_meta_form]') AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
BEGIN
ALTER TABLE [dbo].[form_field_meta] ADD 
	CONSTRAINT [FK_form_field_meta_form] FOREIGN KEY 
	(
		[form_id]
	) REFERENCES [dbo].[form] (
		[form_id]
	)
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_inventory_item]') AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
BEGIN
ALTER TABLE [dbo].[inventory] ADD 
	CONSTRAINT [FK_inventory_item] FOREIGN KEY 
	(
		[item_id]
	) REFERENCES [dbo].[item] (
		[item_id]
	),
	CONSTRAINT [FK_inventory_location] FOREIGN KEY 
	(
		[location_id]
	) REFERENCES [dbo].[location] (
		[location_id]
	)
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_inventory_transations_customer]') AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
BEGIN
ALTER TABLE [dbo].[inventory_transactions] ADD 
	CONSTRAINT [FK_inventory_transations_customer] FOREIGN KEY 
	(
		[customer_id]
	) REFERENCES [dbo].[customer] (
		[customer_id]
	),
	CONSTRAINT [FK_inventory_transations_employee] FOREIGN KEY 
	(
		[user_id]
	) REFERENCES [dbo].[users] (
		[user_id]
	),
	CONSTRAINT [FK_inventory_transations_inventory] FOREIGN KEY 
	(
		[inventory_id]
	) REFERENCES [dbo].[inventory] (
		[inventory_id]
	)
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_item_category]') AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
BEGIN
ALTER TABLE [dbo].[item] ADD 
	CONSTRAINT [FK_item_category] FOREIGN KEY 
	(
		[category_id]
	) REFERENCES [dbo].[category] (
		[category_id]
	),
	CONSTRAINT [FK_item_manufacturer] FOREIGN KEY 
	(
		[manufacturer_id]
	) REFERENCES [dbo].[manufacturer] (
		[manufacturer_id]
	),
	CONSTRAINT [FK_item_supplier] FOREIGN KEY 
	(
		[supplier_id]
	) REFERENCES [dbo].[supplier] (
		[supplier_id]
	)
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_location_sites]') AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
BEGIN
ALTER TABLE [dbo].[location] ADD 
	CONSTRAINT [FK_location_sites] FOREIGN KEY 
	(
		[site_id]
	) REFERENCES [dbo].[sites] (
		[site_id]
	)
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_lookup_transfer_map]') AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
BEGIN
ALTER TABLE [dbo].[lookup] ADD 
	CONSTRAINT [FK_lookup_transfer_map] FOREIGN KEY 
	(
		[map_id]
	) REFERENCES [dbo].[transfer_map] (
		[map_id]
	)
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_pick_order_ship_methods]') AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
BEGIN
ALTER TABLE [dbo].[pick_order] ADD 
	CONSTRAINT [FK_pick_order_ship_methods] FOREIGN KEY 
	(
		[ship_method_id]
	) REFERENCES [dbo].[ship_methods] (
		[ship_method_id]
	)
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_pick_order_detail_item]') AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
BEGIN
ALTER TABLE [dbo].[pick_order_detail] ADD 
	CONSTRAINT [FK_pick_order_detail_item] FOREIGN KEY 
	(
		[item_id]
	) REFERENCES [dbo].[item] (
		[item_id]
	),
	CONSTRAINT [FK_pick_order_detail_pick_order] FOREIGN KEY 
	(
		[pick_order_id]
	) REFERENCES [dbo].[pick_order] (
		[pick_order_id]
	)
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_po_detail_item]') AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
BEGIN
ALTER TABLE [dbo].[po_detail] ADD 
	CONSTRAINT [FK_po_detail_item] FOREIGN KEY 
	(
		[item_id]
	) REFERENCES [dbo].[item] (
		[item_id]
	),
	CONSTRAINT [FK_po_detail_po_master] FOREIGN KEY 
	(
		[po_id]
	) REFERENCES [dbo].[po_master] (
		[po_id]
	),
	CONSTRAINT [FK_po_detail_unit_of_measure] FOREIGN KEY 
	(
		[uom_id]
	) REFERENCES [dbo].[unit_of_measure] (
		[uom_id]
	)
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_po_master_pay_methods]') AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
BEGIN
ALTER TABLE [dbo].[po_master] ADD 
	CONSTRAINT [FK_po_master_pay_methods] FOREIGN KEY 
	(
		[pay_method_id]
	) REFERENCES [dbo].[pay_methods] (
		[pay_method_id]
	),
	CONSTRAINT [FK_po_master_ship_methods] FOREIGN KEY 
	(
		[ship_method_id]
	) REFERENCES [dbo].[ship_methods] (
		[ship_method_id]
	)
END
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'FK_pick_order_ext_pick_order') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
BEGIN
	ALTER TABLE [dbo].[pick_order_ext]  WITH CHECK ADD  CONSTRAINT [FK_pick_order_ext_pick_order] FOREIGN KEY([pick_order_id])
REFERENCES [dbo].[pick_order] ([pick_order_id])

	ALTER TABLE [dbo].[pick_order_ext] CHECK CONSTRAINT [FK_pick_order_ext_pick_order]
END
GO



IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_transfer_field_mapping_transfer_map]') AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
BEGIN
ALTER TABLE [dbo].[transfer_field_mapping] ADD 
	CONSTRAINT [FK_transfer_field_mapping_transfer_map] FOREIGN KEY 
	(
		[map_id]
	) REFERENCES [dbo].[transfer_map] (
		[map_id]
	)
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_employee_privileges_employee]') AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
BEGIN
ALTER TABLE [dbo].[user_privileges] ADD 
	CONSTRAINT [FK_employee_privileges_employee] FOREIGN KEY 
	(
		[user_id]
	) REFERENCES [dbo].[users] (
		[user_id]
	),
	CONSTRAINT [FK_employee_privileges_security_privileges] FOREIGN KEY 
	(
		[security_code]
	) REFERENCES [dbo].[security_privileges] (
		[security_code]
	)
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[pick_order_detail_history]') AND name = N'PK_pick_order_detail_history')
BEGIN
ALTER TABLE [dbo].[pick_order_detail_history] ADD 
	CONSTRAINT [PK_pick_order_detail_history] PRIMARY KEY  CLUSTERED 
	(
		[pick_order_detail_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[pick_order_history]') AND name = N'PK_pick_order_history')
BEGIN
ALTER TABLE [dbo].[pick_order_history] ADD 
	CONSTRAINT [PK_pick_order_history] PRIMARY KEY  CLUSTERED 
	(
		[pick_order_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[po_detail_history]') AND name = N'PK_po_detail_history')
BEGIN
ALTER TABLE [dbo].[po_detail_history] ADD 
	CONSTRAINT [PK_po_detail_history] PRIMARY KEY  CLUSTERED 
	(
		[po_detail_id]
	)  ON [PRIMARY] 
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[po_master_history]') AND name = N'PK_po_master_history')
BEGIN
ALTER TABLE [dbo].[po_master_history] ADD 
	CONSTRAINT [PK_po_master_history] PRIMARY KEY  CLUSTERED 
	(
		[po_id]
	)  ON [PRIMARY] 
END
GO

/********************************************************************************/
/* Added for Version 5 of InventoryControl Security                             */
/********************************************************************************/
IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[user_site]') AND name = N'IX_USER_SITE')
CREATE UNIQUE NONCLUSTERED INDEX [IX_USER_SITE] ON [dbo].[user_site] 
(
	[user_id] ASC,
	[site_id] ASC
) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_user_site_sites]') AND type = 'F')
ALTER TABLE [dbo].[user_site]  WITH CHECK ADD  CONSTRAINT [FK_user_site_sites] FOREIGN KEY([site_id])
REFERENCES [dbo].[sites] ([site_id])
GO

ALTER TABLE [dbo].[user_site] CHECK CONSTRAINT [FK_user_site_sites]
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_user_site_users]') AND type = 'F')
ALTER TABLE [dbo].[user_site]  WITH CHECK ADD  CONSTRAINT [FK_user_site_users] FOREIGN KEY([user_id])
REFERENCES [dbo].[users] ([user_id])
GO
ALTER TABLE [dbo].[user_site] CHECK CONSTRAINT [FK_user_site_users]
GO


/****** Object:  Index [IX_app_options]    Script Date: 04/21/2011 14:53:03 ******/
IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[app_options]') AND name = N'IX_app_options')
CREATE UNIQUE NONCLUSTERED INDEX [IX_app_options] ON [dbo].[app_options] 
(
	[code] ASC,
	[user_id] ASC
)ON [PRIMARY]
GO


/****** Object:  ForeignKey [FK_customer_ext_customer]    Script Date: 04/21/2011 13:34:24 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_customer_ext_customer]') AND type = 'F')
ALTER TABLE [dbo].[customer_ext]  WITH CHECK ADD  CONSTRAINT [FK_customer_ext_customer] FOREIGN KEY([customer_id])
REFERENCES [dbo].[customer] ([customer_id])
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_customer_ext_customer]') AND type = 'F')
ALTER TABLE [dbo].[customer_ext] CHECK CONSTRAINT [FK_customer_ext_customer]
GO

/****** Object:  ForeignKey [FK_item_ext_item]    Script Date: 04/21/2011 13:34:24 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_item_ext_item]') AND type = 'F')
ALTER TABLE [dbo].[item_ext]  WITH CHECK ADD  CONSTRAINT [FK_item_ext_item] FOREIGN KEY([item_id])
REFERENCES [dbo].[item] ([item_id])
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_item_ext_item]') AND type = 'F')
ALTER TABLE [dbo].[item_ext] CHECK CONSTRAINT [FK_item_ext_item]
GO

/****** Object:  ForeignKey [FK_pick_order_detail_ext_pick_order_detail]    Script Date: 04/21/2011 13:34:24 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_pick_order_detail_ext_pick_order_detail]') AND type = 'F')
ALTER TABLE [dbo].[pick_order_detail_ext]  WITH CHECK ADD  CONSTRAINT [FK_pick_order_detail_ext_pick_order_detail] FOREIGN KEY([pick_order_detail_id])
REFERENCES [dbo].[pick_order_detail] ([pick_order_detail_id])
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_pick_order_detail_ext_pick_order_detail]') AND type = 'F')
ALTER TABLE [dbo].[pick_order_detail_ext] CHECK CONSTRAINT [FK_pick_order_detail_ext_pick_order_detail]
GO

/****** Object:  ForeignKey [FK_pick_order_ext_pick_order]    Script Date: 04/21/2011 13:34:24 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_pick_order_ext_pick_order]') AND type = 'F')
ALTER TABLE [dbo].[pick_order_ext]  WITH CHECK ADD  CONSTRAINT [FK_pick_order_ext_pick_order] FOREIGN KEY([pick_order_id])
REFERENCES [dbo].[pick_order] ([pick_order_id])
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_pick_order_ext_pick_order]') AND type = 'F')
ALTER TABLE [dbo].[pick_order_ext] CHECK CONSTRAINT [FK_pick_order_ext_pick_order]
GO

/****** Object:  ForeignKey [FK_po_detail_ext_po_detail]    Script Date: 04/21/2011 13:34:24 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_po_detail_ext_po_detail]') AND type = 'F')
ALTER TABLE [dbo].[po_detail_ext]  WITH CHECK ADD  CONSTRAINT [FK_po_detail_ext_po_detail] FOREIGN KEY([po_detail_id])
REFERENCES [dbo].[po_detail] ([po_detail_id])
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_po_detail_ext_po_detail]') AND type = 'F')
ALTER TABLE [dbo].[po_detail_ext] CHECK CONSTRAINT [FK_po_detail_ext_po_detail]
GO


/****** Object:  ForeignKey [FK_supplier_ext_supplier]    Script Date: 04/21/2011 13:34:24 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_supplier_ext_supplier]') AND type = 'F')
ALTER TABLE [dbo].[supplier_ext]  WITH CHECK ADD  CONSTRAINT [FK_supplier_ext_supplier] FOREIGN KEY([supplier_id])
REFERENCES [dbo].[supplier] ([supplier_id])
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_supplier_ext_supplier]') AND type = 'F')
ALTER TABLE [dbo].[supplier_ext] CHECK CONSTRAINT [FK_supplier_ext_supplier]
GO



