
USE [master]


PRINT ''
PRINT ''
PRINT '**************************************'
PRINT 'Setup DB Option to Truncate log       '
PRINT '**************************************'
PRINT ''


ALTER DATABASE WaspTrackInventory
SET RECOVERY FULL
GO

DBCC SHRINKDATABASE (WaspTrackInventory)
Go




USE [WaspTrackInventory]
GO


print '----------------------------'
print '--                          '
print '--  Create Wasp Accounts    '
print '--                          '
print '----------------------------'


if  EXISTS (select * from dbo.sysusers where name = N'InventoryUser' and uid < 16382)
BEGIN
	print 'drop InventoryUser'
	exec sp_dropuser N'InventoryUser'
END
GO

if not EXISTS (select * from master.dbo.syslogins where loginname = N'InventoryUser')
BEGIN
	declare @logindb nvarchar(132), @loginlang nvarchar(132) select @logindb = N'master', @loginlang = N'us_english'
	if @logindb is null or not EXISTS (select * from master.dbo.sysdatabases where name = @logindb)
		select @logindb = N'master'
	if @loginlang is null or (not EXISTS (select * from master.dbo.syslanguages where name = @loginlang) and @loginlang <> N'us_english')
		select @loginlang = @@language
	exec sp_addlogin N'InventoryUser', Mobile@07Mobile@07, @logindb, @loginlang
	print 'Recreate InventoryUser'
END
else
BEGIN
	PRINT 'InventoryUser exists in syslogins, add user, change password'
	EXEC sp_adduser N'InventoryUser'
	EXEC sp_change_users_login 'Update_One', 'InventoryUser', 'InventoryUser'
	EXEC sp_password NULL, 'Mobile@07Mobile@07', 'InventoryUser'
END
GO


if not EXISTS (select * from dbo.sysusers where name = N'InventoryUser' and uid < 16382)
	EXEC sp_grantdbaccess N'InventoryUser', N'InventoryUser'
GO

exec sp_addsrvrolemember N'InventoryUser', N'dbcreator' 
GO

exec sp_addrolemember N'db_backupoperator', N'InventoryUser'
GO
exec sp_addrolemember N'db_owner', N'InventoryUser'
GO

exec sp_addrolemember N'db_datareader', N'InventoryUser'
GO

exec sp_addrolemember N'db_datawriter', N'InventoryUser'
GO




if  EXISTS (select * from dbo.sysusers where name = N'InventoryReader' and uid < 16382)
BEGIN
	exec sp_dropuser N'InventoryReader'
END
GO

if not EXISTS (select * from master.dbo.syslogins where loginname = N'InventoryReader')
BEGIN
	declare @logindb nvarchar(132), @loginlang nvarchar(132) select @logindb = N'master', @loginlang = N'us_english'
	if @logindb is null or not EXISTS (select * from master.dbo.sysdatabases where name = @logindb)
		select @logindb = N'master'
	if @loginlang is null or (not EXISTS (select * from master.dbo.syslanguages where name = @loginlang) and @loginlang <> N'us_english')
		select @loginlang = @@language
	exec sp_addlogin N'InventoryReader', ReadOnly@1ReadOnly@1, @logindb, @loginlang
END
else
BEGIN
	PRINT 'InventoryReader exists in syslogins, add user, change password'
	EXEC sp_adduser N'InventoryReader'
	EXEC sp_change_users_login 'Update_One', 'InventoryReader', 'InventoryReader'
	EXEC sp_password NULL, 'ReadOnly@1ReadOnly@1', 'InventoryReader'
END
GO

if not EXISTS (select * from dbo.sysusers where name = N'InventoryReader' and uid < 16382)
	EXEC sp_grantdbaccess N'InventoryReader', N'InventoryReader'
GO


exec sp_addrolemember N'db_datareader', N'InventoryReader'
GO



DECLARE @spname varchar(255)
DECLARE @sql varchar(255)

DECLARE SPnames CURSOR FOR
select distinct so.[Name]
from sysobjects so
where so.[Type] = 'P' and so.[Name] like 'Sp%'

OPEN SPnames

 
WHILE 1=1
begin
   	FETCH SPnames INTO @spname 
	if (@@FETCH_STATUS <> 0) break
	select @sql = 'grant EXECUTE ON [dbo].[' + @spname +']  TO [InventoryReader]'
	exec(@sql)

	select @sql = 'grant EXECUTE ON [dbo].[' + @spname +']  TO [InventoryUser]'
	exec(@sql)
end

CLOSE SPnames
DEALLOCATE SPnames
GO
