
USE [WaspTrackInventory]
GO


print '----------------------------'
print '--                          '
print '--  DROP TABLE SECTION      '
print '--                          '
print '----------------------------'


if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[asset]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [dbo].[asset]

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[employees]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [dbo].[employees]


if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[item_primary_locations]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [dbo].[item_primary_locations]


GO


print '-------------------------'
print '--                       '
print '--  CREATE TABLE SECTION '
print '--                       '
print '-------------------------'


SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[address]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[address] (
		[address_id] [int] NOT NULL ,
		[table_name] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[address_type_id] [int] NOT NULL ,
		[record_type] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[address1] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[address2] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[address3] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[address4] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[city] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[state] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[postal_code] [varchar] (10) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[country] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[mail_stop] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[record_status] [record_status_type] NOT NULL 
	) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[app_options]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[app_options] (
		[user_id] [int] NULL ,
		[code] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[type] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[name] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[description] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[tool_tip] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[flag] [wtbool] NULL ,
		[admin] [wtbool] NULL ,
		[option_value] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[option_section] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[record_status] [record_status_type] NULL ,
		[company_id] [int] NOT NULL 
	) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[audit_transactions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[audit_transactions] (
		[transaction_id] [int] IDENTITY (1, 1) NOT NULL ,
		[item_id] [int] NOT NULL ,
		[location_id] [int] NOT NULL ,
		[user_id] [int] NULL ,
		[inventory_id] [int] NULL ,
		[trans_type] [int] NOT NULL ,
		[action_type] [int] NULL ,
		[entry_date] [datetime] NULL ,
		[trans_date] [datetime] NULL ,
		[date_acquired] [datetime] NULL ,
		[quantity] [decimal](18, 4) NULL ,
		[current_qty] [decimal](18, 4) NULL ,
		[remaining_qty] [decimal](18, 4) NULL ,
		[cost] [decimal](18, 4) NULL ,
		[other_id] [int] NOT NULL ,
		[customer_id] [int] NOT NULL ,
		[supplier_id] [int] NOT NULL ,
		[po_id] [int] NULL ,
		[invoice_id] [int] NULL ,
		[serial_number] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[date_code] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[po] [varchar] (38) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[pallet] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[lot] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[adjust_trans_code] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[record_source] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[company_id] [int] NOT NULL 
	) ON [PRIMARY]
END
ELSE if NOT EXISTS (select * from dbo.syscolumns where name = 'po' and id = object_id(N'[dbo].[audit_transactions]'))
BEGIN
	ALTER TABLE [dbo].[audit_transactions] ALTER COLUMN [po] varchar(38)
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[auto_numbers]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[auto_numbers] (
		[object_type] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[company_id] [int] NOT NULL ,
		[next_id] [numeric](30, 0) NULL 
	) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[category]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[category] (
		[category_id] [int] IDENTITY (1000, 1) NOT NULL ,
		[description] [description_type] NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NOT NULL 
	) ON [PRIMARY]
END
GO



if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[company_info]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[company_info] (
		[company_id] [int] NOT NULL ,
		[company] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[email] [varchar] (250) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[website] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[record_status] [record_status_type] NOT NULL 
	) ON [PRIMARY]
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[customer]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[customer] (
		[customer_id] [int] IDENTITY (1000, 1) NOT NULL ,
		[customer_number] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[name] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[company_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[email] [varchar] (250) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[department] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[allow_shorting] [wtbool] NULL ,
		[date_added] [datetime] NULL ,
		[usrdefdate1] [datetime] NULL ,
		[usrdefdate2] [datetime] NULL ,
		[usrdefdate3] [datetime] NULL ,
		[usrdefdate4] [datetime] NULL ,
		[usrdefdate5] [datetime] NULL ,
		[usrdefnumber1] [decimal](15, 4) NULL ,
		[usrdefnumber2] [decimal](15, 4) NULL ,
		[usrdefnumber3] [decimal](15, 4) NULL ,
		[usrdefnumber4] [decimal](15, 4) NULL ,
		[usrdefnumber5] [decimal](15, 4) NULL ,
		[usrdeftext1] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext2] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext3] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext4] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext5] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext6] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext7] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext8] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext9] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext10] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NOT NULL ,
		[update_user_id] [int] NULL ,
		[list_id] [qb_list_id] NULL,
		[last_modified_date] [datetime] NULL
	) ON [PRIMARY]
END
else if NOT EXISTS (select * from dbo.syscolumns where name = 'last_modified_date' and id = object_id(N'[dbo].[customer]'))
BEGIN
	ALTER TABLE [dbo].[customer] ADD [last_modified_date] [datetime] NULL  
END
GO



if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[find_meta]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[find_meta] (
		[rec_id] [int] IDENTITY (1, 1) NOT NULL ,
		[form_id] [int] NOT NULL ,
		[user_id] [int] NOT NULL ,
		[company_id] [int] NOT NULL ,
		[selected_form_id] [int] NULL ,
		[device_name] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[field_id] [int] NULL ,
		[field_value] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[filter] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[whole_word_flag] [wtbool] NULL ,
		[advanced_flag] [wtbool] NULL ,
		[find_all_flag] [wtbool] NULL 
	) ON [PRIMARY]
END
else if NOT EXISTS (select * from dbo.syscolumns where name = 'device_name' and id = object_id(N'[dbo].[find_meta]'))
BEGIN
ALTER TABLE [dbo].[find_meta] ADD 
	[device_name] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[form]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[form] (
		[form_id] [int] NOT NULL ,
		[form_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[list_flag] [wtbool] NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NOT NULL 
	) ON [PRIMARY]
END
GO
if NOT EXISTS (select * from dbo.syscolumns where name = 'user_editable' and id = object_id(N'[dbo].[form]'))
BEGIN
ALTER TABLE [dbo].[form] ADD 
[user_editable] [wtbool] NOT NULL default('T')
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[form_field_meta]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[form_field_meta] (
		[form_id] [int] NOT NULL ,
		[control] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[field] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[db_field] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[label] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[tool_tip] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[visible] [wtbool] NULL ,
		[required] [wtbool] NULL ,
		[user_editable] [wtbool] NULL ,
		[field_length] [int] NULL ,
		[default_label] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[default_tool_tip] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[default_visible] [wtbool] NULL ,
		[default_required] [wtbool] NULL ,
		[default_field_length] [int] NULL ,
		[data_type] [int] NULL ,
		[send_to_palm] [wtbool] NULL ,
		[sort_order] [int] NULL ,
		[record_status] [record_status_type] NULL ,
		[company_id] [int] NULL ,
		[should_find] [char] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[should_export] [char] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[should_import] [char] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[usrdef_allow_user_key_in_value] [char](1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL CONSTRAINT [DF_form_field_meta_usrdef_allow_user_key_in_value]  DEFAULT ('T'),
	) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[history_transactions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[history_transactions] (
		[transaction_id] [int],
		[item_id] [int] NOT NULL ,
		[location_id] [int] NOT NULL ,
		[user_id] [int] NULL ,
		[line_item_id] [int] NULL ,
		[inventory_id] [int] NULL ,
		[trans_type] [int] NOT NULL ,
		[action_type] [int] NULL ,
		[entry_date] [datetime] NULL ,
		[trans_date] [datetime] NULL ,
		[date_acquired] [datetime] NULL ,
		[adjust_type] [char] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[quantity] [decimal](18, 4) NULL ,
		[current_qty] [decimal](18, 4) NULL ,
		[remaining_qty] [decimal](18, 4) NULL ,
		[cost] [decimal](18, 4) NULL ,
		[other_id] [int] NOT NULL ,
		[customer_id] [int] NOT NULL ,
		[supplier_id] [int] NOT NULL ,
		[serial_number] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[date_code] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[po] [varchar] (38) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[lot] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[pallet] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[po_id] [int] NOT NULL ,
		[invoice_id] [int] NOT NULL ,
		[adjust_reason_id] [int] NULL ,
		[print_label_no] [int] NULL ,
		[adjust_trans_code] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[record_source] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[company_id] [int] NULL ,
		[is_receive_or_ship] [wtbool] NOT NULL ,
		[receipt_no] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
		[item_type] [int] NULL
	) ON [PRIMARY]
END
else 
BEGIN
	if NOT EXISTS (select * from dbo.syscolumns where name = 'is_receive_or_ship' and id = object_id(N'[dbo].[history_transactions]'))
	BEGIN
	ALTER TABLE [dbo].[history_transactions] ADD 
		[is_receive_or_ship] [wtbool] NOT NULL CONSTRAINT [DF_history_transactions_is_receive_or_ship] DEFAULT ('F'),
		[receipt_no] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
	END

	if EXISTS (select * from dbo.syscolumns where name = 'po' and id = object_id(N'[dbo].[history_transactions]'))
	BEGIN
		ALTER TABLE [dbo].[history_transactions] ALTER COLUMN [po] varchar(38)
	END

	if NOT EXISTS (select * from dbo.syscolumns where name = 'item_type' and id = object_id(N'[dbo].[history_transactions]'))
	BEGIN
		ALTER TABLE [dbo].[history_transactions] ADD [item_type] [int] NULL
	END
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[image]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[image] (
		[image_id] [int] NOT NULL ,
		[image_label] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[image] [image] NULL 
	) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
END
GO



if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[import_export_errors]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[import_export_errors] (
		[id] [int] IDENTITY (1, 1) NOT NULL ,
		[process_id] [int] NOT NULL ,
		[original_data] [varchar] (1000) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[error_number] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[error_description] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[internal_id] [int] NULL ,
		[dvalue] [decimal](18, 4) NULL 
	) ON [PRIMARY]
END
GO



if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[inv_audit]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[inv_audit] (
		[site] [int] NOT NULL ,
		[start_date] [datetime] NOT NULL ,
		[end_date] [datetime] NULL ,
		[company_id] [int] NOT NULL ,
		[record_status] [record_status_type] NOT NULL 
	) ON [PRIMARY]
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[inventory]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[inventory] (
		[inventory_id] [int] IDENTITY (1, 1) NOT NULL ,
		[item_id] [int] NOT NULL ,
		[location_id] [int] NOT NULL ,
		[quantity] [decimal](18, 4) NOT NULL ,
		[max_stock_level] [decimal](18, 4) NOT NULL ,
		[min_stock_level] [decimal](18, 4) NOT NULL ,
		[reorder_qty] [decimal](18, 4) NOT NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NOT NULL ,
		[primary_location] [wtbool] NOT NULL ,
		[lsgrid_only] [wtbool] NOT NULL 
	) ON [PRIMARY]
END
else if NOT EXISTS (select * from dbo.syscolumns where name = 'primary_location' and id = object_id(N'[dbo].[inventory]'))
BEGIN
ALTER TABLE [dbo].[inventory] ADD 
	[primary_location] [wtbool] NOT NULL CONSTRAINT [DF_inventory_primary_location] DEFAULT ('F'),
	[lsgrid_only] [wtbool] NOT NULL CONSTRAINT [DF_inventory_lsform_only] DEFAULT ('F')
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[inventory_request]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[inventory_request] (
		[inventory_request_id] [int] IDENTITY (1, 1) NOT NULL ,
		[request_number] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[creation_date] [datetime] NULL ,
		[last_modified_date] [datetime] NULL ,
		[due_date] [datetime] NULL ,
		[ship_date] [datetime] NULL ,
		[request_status] [int] NOT NULL ,
		[customer_id] [int] NULL ,
		[carrier] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[tracking_number] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[staging_location_id] [int] NULL ,
		[is_canceled] [wtbool] NOT NULL ,
		[company_id] [int] NOT NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[line_item_count] [int] NOT NULL ,
		[parent_id] [int] NOT NULL ,
		[backorder_id] [int] NOT NULL ,
		[is_printed] [wtbool] NULL ,
		[print_no] [int] NOT NULL ,
		[last_printed_date] [datetime] NULL 
	) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[inventory_request_detail]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[inventory_request_detail] (
		[inventory_request_line_item_id] [int] NOT NULL ,
		[site] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[location] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[is_selected] [wtbool] NOT NULL 
	) ON [PRIMARY]
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[inventory_request_line_item]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[inventory_request_line_item] (
		[line_item_id] [int] IDENTITY (1, 1) NOT NULL ,
		[inventory_request_id] [int] NOT NULL ,
		[item_id] [int] NOT NULL ,
		[request_quantity] [decimal](15, 4) NOT NULL ,
		[picked_quantity] [decimal](15, 4) NOT NULL ,
		[shipped_quantity] [decimal](15, 4) NOT NULL ,
		[company_id] [int] NOT NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[backorder] [wtbool] NULL 
	) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[inventory_request_manual_line]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[inventory_request_manual_line] (
	[manual_line_id] [int] IDENTITY (1, 1) NOT NULL ,
	[inventory_request_id] [int] NOT NULL ,
	[item_number] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[description] [varchar] (1000) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[date_acquired] [datetime] NULL ,
	[cost] [money] NOT NULL ,
	[quantity] [decimal](15, 4) NOT NULL ,
	[picked_quantity] [decimal](15, 4) NOT NULL ,
	[shipped_quantity] [decimal](15, 4) NOT NULL ,
	[company_id] [int] NOT NULL ,
	[record_status] [record_status_type] NOT NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[inventory_temp]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[inventory_temp](
	[item_number] [varchar](31) NULL,
	[item_desc] [varchar](255) NULL,
	[site_name] [varchar](30) NULL,
	[code] [varchar](30) NULL,
	[pallet] [varchar](30) NULL,
	[lot] [varchar](30) NULL,
	[po] [varchar](38) NULL,
	[date_code] [varchar](30) NULL,
	[serial_number] [varchar](30) NULL,
	[quantity] [decimal](18, 0) NULL,
	[supplier_number] [varchar](30) NULL,
	[date_acquired] [datetime] NULL,
	[min_stock_level] [decimal](18, 0) NULL,
	[max_stock_level] [decimal](18, 0) NULL,
	[reorder_qty] [decimal](18, 0) NULL
) ON [PRIMARY]
END
else if EXISTS (select * from dbo.syscolumns where name = 'po' and id = object_id(N'[dbo].[inventory_temp]'))
BEGIN
	ALTER TABLE [dbo].[inventory_temp] ALTER COLUMN [po] varchar(38)
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[inventory_transactions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[inventory_transactions] (
	[transaction_id] [int] IDENTITY (1, 1) NOT NULL ,
	[item_id] [int] NOT NULL ,
	[location_id] [int] NOT NULL ,
	[user_id] [int] NULL ,
	[line_item_id] [int] NULL ,
	[inventory_id] [int] NULL ,
	[trans_type] [int] NOT NULL ,
	[action_type] [int] NULL ,
	[entry_date] [datetime] NULL ,
	[trans_date] [datetime] NULL ,
	[date_acquired] [datetime] NULL ,
	[adjust_type] [char] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[quantity] [decimal](18, 4) NULL ,
	[current_qty] [decimal](18, 4) NULL ,
	[remaining_qty] [decimal](18, 4) NULL ,
	[cost] [decimal](18, 4) NULL ,
	[other_id] [int] NOT NULL ,
	[customer_id] [int] NOT NULL ,
	[supplier_id] [int] NOT NULL ,
	[serial_number] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[date_code] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[po] [varchar] (38) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[lot] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[pallet] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[po_id] [int] NOT NULL ,
	[invoice_id] [int] NOT NULL ,
	[adjust_reason_id] [int] NULL ,
	[print_label_no] [int] NULL ,
	[adjust_trans_code] [varchar] (25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[record_source] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[company_id] [int] NULL ,
	[is_receive_or_ship] [wtbool] NOT NULL ,
	[receipt_no] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[other_transaction_id] [int] NULL CONSTRAINT [DF_inventory_transactions_other_transaction_id]  DEFAULT ((0))
) ON [PRIMARY]
END
else 
BEGIN
	if NOT EXISTS (select * from dbo.syscolumns where name = 'is_receive_or_ship' and id = object_id(N'[dbo].[inventory_transactions]'))
	BEGIN
	ALTER TABLE [dbo].[inventory_transactions] ADD 
		[is_receive_or_ship] [wtbool] NOT NULL CONSTRAINT [DF_inventory_transactions_is_receive_or_ship] DEFAULT ('F'),
		[receipt_no] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
	END

	if EXISTS (select * from dbo.syscolumns where name = 'po' and id = object_id(N'[dbo].[inventory_transactions]'))
	BEGIN
		ALTER TABLE [dbo].[inventory_transactions] ALTER COLUMN [po] varchar(38)
	END

	if NOT EXISTS (select * from dbo.syscolumns where name = 'other_transaction_id' and id = object_id(N'[dbo].[inventory_transactions]'))
	BEGIN
		ALTER TABLE [dbo].[inventory_transactions] ADD 
			[other_transaction_id] [int] NULL CONSTRAINT [DF_inventory_transactions_other_transaction_id]  DEFAULT ((0))
	END
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[invoice_line_items]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[invoice_line_items] (
	[line_item_id] [int] IDENTITY (1, 1) NOT NULL ,
	[txn_line_id] [qb_list_id] NULL ,
	[invoice_id] [int] NOT NULL ,
	[item_id] [int] NOT NULL ,
	[quantity] [decimal](18, 4) NOT NULL ,
	[picked_quantity] [decimal](18, 4) NOT NULL ,
	[company_id] [int] NOT NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[amount] [decimal](18, 4) NOT NULL ,
	[backorder] [wtbool] NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[invoice_line_items_archive]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[invoice_line_items_archive] (
	[line_item_id] [int] NOT NULL ,
	[txn_line_id] [qb_list_id] NULL ,
	[invoice_id] [int] NOT NULL ,
	[item_id] [int] NOT NULL ,
	[quantity] [decimal](18, 4) NOT NULL ,
	[picked_quantity] [decimal](18, 4) NOT NULL ,
	[company_id] [int] NOT NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[amount] [decimal](18, 4) NOT NULL ,
	[backorder] [wtbool] NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[invoice_master]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[invoice_master] (
	[invoice_id] [int] IDENTITY (1, 1) NOT NULL ,
	[ref_number] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[customer_id] [int] NULL ,
	[is_pending] [wtbool] NULL ,
	[txn_id] [qb_list_id] NOT NULL ,
	[txn_number] [int] NOT NULL ,
	[due_date] [datetime] NULL ,
	[invoice_status] [int] NOT NULL ,
	[company_id] [int] NOT NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[edit_sequence] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[line_item_count] [int] NOT NULL ,
	[parent_id] [int] NOT NULL ,
	[backorder_id] [int] NOT NULL ,
	[po_number] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[is_printed] [wtbool] NULL ,
	[date_printed] [datetime] NULL ,
	[has_error] [wtbool] NULL ,
	[record_status_date] [datetime] NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[invoice_master_archive]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[invoice_master_archive] (
	[invoice_id] [int] NOT NULL ,
	[ref_number] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[customer_id] [int] NULL ,
	[is_pending] [wtbool] NULL ,
	[txn_id] [qb_list_id] NOT NULL ,
	[txn_number] [int] NOT NULL ,
	[due_date] [datetime] NULL ,
	[invoice_status] [int] NOT NULL ,
	[company_id] [int] NOT NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[edit_sequence] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[line_item_count] [int] NOT NULL ,
	[parent_id] [int] NOT NULL ,
	[backorder_id] [int] NOT NULL ,
	[po_number] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[is_printed] [wtbool] NULL ,
	[date_printed] [datetime] NULL ,
	[has_error] [wtbool] NULL ,
	[record_status_date] [datetime] NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[item]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[item](
	[item_id] [int] IDENTITY(1,1) NOT NULL,
	[item_number] [varchar](31) NULL,
	[description] [description_type] NULL,
	[default_location_id] [int] NOT NULL CONSTRAINT [DF_item_default_location_id]  DEFAULT ((0)),
	[cost] [money] NULL,
	[avgcost] [money] NULL,
	[cost_calc_method] [int] NOT NULL CONSTRAINT [DF_item_cost_calc_method]  DEFAULT ((1)),
	[manufacturer_id] [int] NOT NULL CONSTRAINT [DF_item_manufacturer_id]  DEFAULT ((0)),
	[category_id] [int] NOT NULL CONSTRAINT [DF_item_category_id]  DEFAULT ((0)),
	[unit_of_measure] [varchar](10) NULL,
	[reorder_qty] [decimal](15, 4) NULL,
	[alt_item_number] [varchar](30) NULL,
	[linked_file] [varchar](255) NULL,
	[list_price] [money] NULL,
	[sale_price] [money] NULL,
	[supplier_id] [int] NOT NULL CONSTRAINT [DF_item_supplier_id]  DEFAULT ((0)),
	[min_stock_level] [decimal](15, 4) NULL,
	[max_stock_level] [decimal](15, 4) NULL,
	[qty_available] [decimal](18, 4) NULL CONSTRAINT [DF_item_qty_available]  DEFAULT ((0)),
	[qty_checked_out] [decimal](18, 4) NULL CONSTRAINT [DF_item_qty_checked_out]  DEFAULT ((0)),
	[qty_in_house] [decimal](18, 4) NULL CONSTRAINT [DF_item_qty_in_house]  DEFAULT ((0)),
	[track_serial_numbers] [wtbool] NULL CONSTRAINT [DF_item_track_serial_numbers]  DEFAULT ('F'),
	[track_lots] [wtbool] NULL CONSTRAINT [DF_item_track_lots]  DEFAULT ('F'),
	[track_date_codes] [wtbool] NULL,
	[track_pallets] [wtbool] NULL,
	[track_pos] [wtbool] NULL,
	[track_suppliers] [wtbool] NULL,
	[track_customers] [wtbool] NULL,
	[allow_fraction_qty] [wtbool] NULL CONSTRAINT [DF_item_allow_fraction_qty]  DEFAULT ('F'),
	[manager] [varchar](50) NULL,
	[checkout_duration] [int] NULL,
	[width] [varchar](50) NULL,
	[height] [varchar](50) NULL,
	[length] [varchar](50) NULL,
	[dimension_unit] [varchar](50) NULL,
	[weight] [varchar](50) NULL,
	[weight_unit] [varchar](50) NULL,
	[usrdefdate1] [datetime] NULL,
	[usrdefdate2] [datetime] NULL,
	[usrdefdate3] [datetime] NULL,
	[usrdefdate4] [datetime] NULL,
	[usrdefdate5] [datetime] NULL,
	[usrdefnumber1] [decimal](15, 4) NULL,
	[usrdefnumber2] [decimal](15, 4) NULL,
	[usrdefnumber3] [decimal](15, 4) NULL,
	[usrdefnumber4] [decimal](15, 4) NULL,
	[usrdefnumber5] [decimal](15, 4) NULL,
	[usrdeftext1] [varchar](100) NULL,
	[usrdeftext2] [varchar](100) NULL,
	[usrdeftext3] [varchar](100) NULL,
	[usrdeftext4] [varchar](100) NULL,
	[usrdeftext5] [varchar](100) NULL,
	[usrdeftext6] [varchar](100) NULL,
	[usrdeftext7] [varchar](100) NULL,
	[usrdeftext8] [varchar](100) NULL,
	[usrdeftext9] [varchar](100) NULL,
	[usrdeftext10] [varchar](100) NULL,
	[record_status] [record_status_type] NOT NULL,
	[company_id] [int] NULL,
	[list_id] [qb_list_id] NULL,
	[date_updated] [datetime] NULL,
	[auto_sn] [wtbool] NULL CONSTRAINT [DF_item_auto_sn]  DEFAULT ('F'),
	[auto_sn_value] [numeric](18, 0) NULL CONSTRAINT [DF_item_auto_sn_value]  DEFAULT ((0)),
	[item_type] [int] NOT NULL CONSTRAINT [DF_item_type]  DEFAULT ((1)),
	[use_subitem_cost][wtbool] NOT NULL DEFAULT('F'),
 CONSTRAINT [PK_item] PRIMARY KEY CLUSTERED 
(
	[item_id] ASC
) ON [PRIMARY]
) ON [PRIMARY]
END
ELSE
BEGIN
	if NOT EXISTS (select * from dbo.syscolumns where name = 'item_type' and id = object_id(N'[dbo].[item]'))
	BEGIN
		ALTER TABLE [item] ADD 
			item_type [int] NOT NULL CONSTRAINT [DF_item_type] DEFAULT (1)
	END

	if NOT EXISTS (select * from dbo.syscolumns where name = 'cost_calc_method' and id = object_id(N'[dbo].[item]'))
	BEGIN
		ALTER TABLE [dbo].[item] ADD 
			[cost_calc_method] [int] NULL CONSTRAINT [DF_item_cost_calc_method]  DEFAULT ((1))
	END
END
GO

IF EXISTS (SELECT * FROM [dbo].[item] WHERE [cost_calc_method] IS NULL)
BEGIN	
	UPDATE [dbo].[item] SET [cost_calc_method] = 1 WHERE [cost_calc_method] IS NULL
		
	ALTER TABLE [dbo].[item] ALTER COLUMN
			[cost_calc_method] [int] NOT NULL
END
GO

IF NOT EXISTS (SELECT * FROM dbo.syscolumns WHERE name = 'use_subitem_cost' AND id = object_id(N'[dbo].[item]'))
BEGIN
	ALTER TABLE [dbo].[item] ADD 
		[use_subitem_cost] [wtbool] NULL CONSTRAINT [DF_item_use_subitem_cost]  DEFAULT ('T')
END
GO

IF EXISTS (SELECT * FROM dbo.syscolumns WHERE name = 'use_subitem_cost' AND id = object_id(N'[dbo].[item]'))
BEGIN
	IF EXISTS (SELECT * FROM [dbo].[item] WHERE [use_subitem_cost] IS NULL)
	BEGIN	
		UPDATE [dbo].[item] SET [use_subitem_cost] = 'F' WHERE [use_subitem_cost] IS NULL AND item_type NOT IN (5,4)
		
		UPDATE [dbo].[item] SET [use_subitem_cost] = 'T' WHERE [use_subitem_cost] IS NULL AND item_type IN (5,4)
			
		ALTER TABLE [dbo].[item] ALTER COLUMN
				[use_subitem_cost] [wtbool] NOT NULL
	END
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[item_group_spec]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[item_group_spec](
	[line_id] [int] IDENTITY(1,1) NOT NULL,
	[item_id] [int] NOT NULL,
	[sub_item_id] [int] NOT NULL,
	[quantity] [decimal](18, 4) NOT NULL,
	[always_scrap] [wtbool] NOT NULL CONSTRAINT [DF_item_group_spec_alway_scrap]  DEFAULT ('F'),
	[batch_no] [int] NOT NULL,
	[record_status] [record_status_type] NOT NULL,
	[user_id] [int] NOT NULL,
	[last_updated] [datetime] NULL,
	[company_id] [int] NOT NULL
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[item_receipt]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[item_receipt] (
		[item_receipt_id] [int] IDENTITY (1, 1) NOT NULL ,
		[po_id] [int] NOT NULL ,
		[date_received] [datetime] NOT NULL ,
		[line_item_type] [int] NOT NULL ,
		[item_id] [int] NOT NULL ,
		[uom_id] [int] NOT NULL ,
		[quantity_received] [decimal](18, 4) NOT NULL ,
		[cost] [decimal](18, 4) NOT NULL ,
		[company_id] [int] NOT NULL ,
		[record_status] [record_status_type] NOT NULL 
	) ON [PRIMARY]
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[item_supplier]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[item_supplier] (
		[item_supplier_id] [int] IDENTITY (1, 1) NOT NULL ,
		[item_id] [int] NOT NULL ,
		[supplier_id] [int] NOT NULL ,
		[supplier_item_sku] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[supplier_item_description] [description_type] NULL ,
		[lead_time] [decimal](18, 4) NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NOT NULL ,
		[default_supplier] [wtbool] NOT NULL ,
		[note] [description_type] NULL 
	) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[item_type]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[item_type] (
	[item_type_id] [int] NOT NULL ,
	[item_type_name] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[label_names]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[label_names] (
	[lbl_id] [int] NULL ,
	[lbl_type] [int] NULL ,
	[lbl_display_order] [int] NULL ,
	[lbl_name] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[lbl_file_name] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[lbl_default_name] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[lbl_tool_tips] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[location]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[location] (
	[location_id] [int] IDENTITY (1, 1) NOT NULL ,
	[site_id] [int] NULL ,
	[description] [description_type] NULL ,
	[code] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[default_location] [wtbool] NULL ,
	[usrdefdate1] [datetime] NULL ,
	[usrdefdate2] [datetime] NULL ,
	[usrdefdate3] [datetime] NULL ,
	[usrdefdate4] [datetime] NULL ,
	[usrdefdate5] [datetime] NULL ,
	[usrdefnumber1] [decimal](15, 4) NULL ,
	[usrdefnumber2] [decimal](15, 4) NULL ,
	[usrdefnumber3] [decimal](15, 4) NULL ,
	[usrdefnumber4] [decimal](15, 4) NULL ,
	[usrdefnumber5] [decimal](15, 4) NULL ,
	[usrdeftext1] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext2] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext3] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext4] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext5] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext6] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext7] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext8] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext9] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext10] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[company_id] [int] NOT NULL ,
	[update_user_id] [int] NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[lookup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[lookup] (
	[map_id] [int] NOT NULL ,
	[field] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[note] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[data_value] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[autogen] [wtbool] NULL ,
	[zerolength] [wtbool] NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[company_id] [int] NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[manufacturer]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[manufacturer] (
	[manufacturer_id] [int] IDENTITY (1000, 1) NOT NULL ,
	[name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[email] [varchar] (250) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[website] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[contact_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdefdate1] [datetime] NULL ,
	[usrdefdate2] [datetime] NULL ,
	[usrdefdate3] [datetime] NULL ,
	[usrdefdate4] [datetime] NULL ,
	[usrdefdate5] [datetime] NULL ,
	[usrdefnumber1] [decimal](15, 4) NULL ,
	[usrdefnumber2] [decimal](15, 4) NULL ,
	[usrdefnumber3] [decimal](15, 4) NULL ,
	[usrdefnumber4] [decimal](15, 4) NULL ,
	[usrdefnumber5] [decimal](15, 4) NULL ,
	[usrdeftext1] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext2] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext3] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext4] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext5] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext6] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext7] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext8] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext9] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext10] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[company_id] [int] NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[notes]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[notes] (
	[note_id] [int] NOT NULL ,
	[table_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[note_text] [varchar] (1000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[note_date] [datetime] NOT NULL ,
	[note_user_id] [int] NOT NULL 
) ON [PRIMARY]
END
GO



if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[number_template]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[number_template] (
		[format_name] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[f_order_no] [int] NOT NULL ,
		[f_type] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[f_value] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[f_length] [int] NOT NULL ,
		[company_id] [int] NOT NULL 
	) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[pay_methods]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[pay_methods] (
	[pay_method_id] [int] IDENTITY (1, 1) NOT NULL ,
	[pay_method_text] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[company_id] [int] NOT NULL ,
	[record_status] [record_status_type] NOT NULL 
) ON [PRIMARY]
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[phone]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[phone] (
	[phone_id] [int] NOT NULL ,
	[table_name] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[phone_type_id] [int] NOT NULL ,
	[record_type] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[phone_number] [phone_type] NULL ,
	[extension] [varchar] (10) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[record_status] [record_status_type] NOT NULL 
) ON [PRIMARY]
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[pick_order]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[pick_order] (
	[pick_order_id] [int] IDENTITY (1, 1) NOT NULL ,
	[order_number] [varchar] (38) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[creation_date] [datetime] NULL ,
	[last_modified_date] [datetime] NULL ,
	[due_date] [datetime] NULL ,
	[ship_date] [datetime] NULL ,
	[order_status] [int] NOT NULL ,
	[customer_id] [int] NULL ,
	[tracking_number] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[is_canceled] [wtbool] NOT NULL ,
	[company_id] [int] NOT NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[line_item_count] [int] NULL ,
	[backorder_id] [int] NULL ,
	[is_printed] [wtbool] NULL ,
	[print_no] [int] NULL ,
	[last_printed_date] [datetime] NULL ,
	[ref_number] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[customer_address_type_id] [int] NULL ,
	[customer_address_record_type] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[ship_method_id] [int] NULL 
 CONSTRAINT [PK_pick_order] PRIMARY KEY CLUSTERED 
(
	[pick_order_id] ASC
) ON [PRIMARY]
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[pick_order_detail]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[pick_order_detail] (
	[pick_order_detail_id] [int] IDENTITY (1, 1) NOT NULL ,
	[pick_order_id] [int] NOT NULL ,
	[line_item_type] [int] NOT NULL ,
	[item_id] [int] NOT NULL ,
	[item_description] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[item_uom] [varchar] (10) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[request_quantity] [decimal](15, 4) NOT NULL ,
	[picked_quantity] [decimal](15, 4) NOT NULL ,
	[company_id] [int] NOT NULL ,
	[record_status] [record_status_type] NOT NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[po_detail]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[po_detail] (
	[po_detail_id] [int] IDENTITY (1, 1) NOT NULL ,
	[po_id] [int] NOT NULL ,
	[line_item_type] [int] NOT NULL ,
	[item_id] [int] NOT NULL ,
	[item_description] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[vendor_sku] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[uom_id] [int] NOT NULL ,
	[quantity_ordered] [decimal](18, 4) NOT NULL ,
	[quantity_received] [decimal](18, 4) NOT NULL ,
	[quantity_original] [decimal](18, 4) NOT NULL ,
	[cost] [money] NOT NULL ,
	[company_id] [int] NOT NULL ,
	[record_status] [record_status_type] NOT NULL 
) ON [PRIMARY]
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[po_invoice_status]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[po_invoice_status] (
	[status_id] [int] NOT NULL ,
	[description] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[po_lineitem_type]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[po_lineitem_type] (
	[po_lineitem_type_id] [int] NOT NULL ,
	[po_lineitem_type_name] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
END
GO



IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[po_master]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[po_master] (
	[po_id] [int] IDENTITY (1, 1) NOT NULL ,
	[po_type] [varchar] (10) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[po_number] [nvarchar] (38) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[ref_number] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[supplier_id] [int] NULL ,
	[customer_id] [int] NULL ,
	[order_date] [datetime] NULL ,
	[due_date] [datetime] NULL ,
	[ship_method_id] [int] NULL ,
	[pay_method_id] [int] NULL ,
	[po_status] [int] NOT NULL ,
	[last_modified_date] [datetime] NULL,
	[company_id] [int] NOT NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[record_status_date] [datetime] NULL ,
	[supplier_address_type_id] [int] NULL ,
	[supplier_address_record_type] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[shipping_address_type_id] [int] NULL,
	[shipping_address_record_type] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[is_dropship] [wtbool] NOT NULL CONSTRAINT [DF_po_master_is_dropship]  DEFAULT ('F'),
	[external_key] [varchar](100) NULL
) ON [PRIMARY]
END
ELSE
BEGIN
	if NOT EXISTS (select * from dbo.syscolumns where name = 'is_dropship' and id = object_id(N'[dbo].[po_master]'))
	BEGIN
		ALTER TABLE [dbo].[po_master] ADD [is_dropship] [wtbool] NOT NULL CONSTRAINT [DF_po_master_is_dropship]  DEFAULT ('F')
	END

	if NOT EXISTS (select * from dbo.syscolumns where name = 'external_key' and id = object_id(N'[dbo].[po_master]'))
	BEGIN
		ALTER TABLE [dbo].[po_master] ADD [external_key] [varchar](100) NULL
	END
END
GO




if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[po_status]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[po_status] (
	[po_status_id] [int] NOT NULL ,
	[po_status_text] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[company_id] [int] NOT NULL ,
	[record_status] [record_status_type] NOT NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[reasons_adjustment]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[reasons_adjustment] (
	[reason_id] [int] IDENTITY (1, 1) NOT NULL ,
	[sort_order] [int] NULL ,
	[adjust_code] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[description] [varchar] (1000) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[calculation_method] [int] NOT NULL ,
	[company_id] [int] NOT NULL ,
	[record_status] [record_status_type] NOT NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[recent_values]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[recent_values] (
	[id] [int] IDENTITY (1, 1) NOT NULL ,
	[user_id] [int] NOT NULL ,
	[form_id] [int] NULL ,
	[code] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[recent_id] [int] NULL ,
	[recent_value] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[recent_date] [datetime] NULL 
) ON [PRIMARY]
END
else
BEGIN
	ALTER TABLE [dbo].[recent_values] ALTER COLUMN 
		[code] [varchar](30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[record_status]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[record_status] (
	[status_id] [smallint] NOT NULL ,
	[description] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[report_filters]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[report_filters] (
	[rpt_id] [int] NOT NULL ,
	[rpt_filter_index] [int] NOT NULL ,
	[rpt_filter_name] [char] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[rpt_filter_name_show] [char] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[report_hidden_fields]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[report_hidden_fields] (
	[hidden_fields] [char] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[report_label_types]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[report_label_types] (
	[type_id] [int] NULL ,
	[type_display_order] [int] NULL ,
	[type_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[type_default_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[report_labels]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[report_labels] (
	[rpt_id] [int] NULL ,
	[db_field_report] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[rpt_label] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[rpt_label2] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[form_id] [int] NULL ,
	[db_field] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[field] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[report_names]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[report_names] (
	[rpt_id] [int] NULL ,
	[rpt_type] [int] NULL ,
	[rpt_display_order] [int] NULL ,
	[rpt_name] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[rpt_file_name] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[rpt_default_name] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[rpt_filter] [wtbool] NULL ,
	[rpt_show_dialog] [wtbool] NULL ,
	[rpt_tool_tips] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[rpt_orientation] [nvarchar] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL DEFAULT ('P')
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[request_status]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[request_status] (
	[status_id] [int] NULL ,
	[code] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[label] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[security_privileges]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[security_privileges] (
	[security_code] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[description] [description_type] NOT NULL ,
	[company_id] [int] NULL 
) ON [PRIMARY]
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[ship_methods]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[ship_methods] (
	[ship_method_id] [int] IDENTITY (1, 1) NOT NULL ,
	[ship_method_text] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[company_id] [int] NOT NULL ,
	[record_status] [record_status_type] NOT NULL 
) ON [PRIMARY]
END
GO



if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[sites]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[sites] (
	[site_id] [int] IDENTITY (1, 1) NOT NULL ,
	[site_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[description] [description_type] NULL ,
	[usrdefdate1] [datetime] NULL ,
	[usrdefdate2] [datetime] NULL ,
	[usrdefdate3] [datetime] NULL ,
	[usrdefdate4] [datetime] NULL ,
	[usrdefdate5] [datetime] NULL ,
	[usrdefnumber1] [decimal](15, 4) NULL ,
	[usrdefnumber2] [decimal](15, 4) NULL ,
	[usrdefnumber3] [decimal](15, 4) NULL ,
	[usrdefnumber4] [decimal](15, 4) NULL ,
	[usrdefnumber5] [decimal](15, 4) NULL ,
	[usrdeftext1] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext2] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext3] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext4] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext5] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext6] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext7] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext8] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext9] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext10] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[company_id] [int] NOT NULL ,
	[update_user_id] [int] NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[supplier]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[supplier] (
	[supplier_id] [int] IDENTITY (1000, 1) NOT NULL ,
	[supplier_number] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[email] [varchar] (250) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[website] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[contact_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdefdate1] [datetime] NULL ,
	[usrdefdate2] [datetime] NULL ,
	[usrdefdate3] [datetime] NULL ,
	[usrdefdate4] [datetime] NULL ,
	[usrdefdate5] [datetime] NULL ,
	[usrdefnumber1] [decimal](15, 4) NULL ,
	[usrdefnumber2] [decimal](15, 4) NULL ,
	[usrdefnumber3] [decimal](15, 4) NULL ,
	[usrdefnumber4] [decimal](15, 4) NULL ,
	[usrdefnumber5] [decimal](15, 4) NULL ,
	[usrdeftext1] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext2] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext3] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext4] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext5] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext6] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext7] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext8] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext9] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[usrdeftext10] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[company_id] [int] NULL ,
	[update_user_id] [int] NULL ,
	[list_id] [qb_list_id] NULL ,
	[last_modified_date] [datetime] NULL
	) ON [PRIMARY]
END
else if NOT EXISTS (select * from dbo.syscolumns where name = 'last_modified_date' and id = object_id(N'[dbo].[supplier]'))
BEGIN
	ALTER TABLE [dbo].[supplier] ADD [last_modified_date] [datetime] NULL
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[transaction_temp]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[transaction_temp] (
	[item_number] [varchar] (31) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[description] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[site_name] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[code] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[other_site] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[other_location] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[pallet] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[lot] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[date_code] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[serial_number] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[trans_type] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[trans_date] [datetime] NULL ,
	[quantity] [decimal](18, 0) NULL ,
	[current_qty] [decimal](18, 0) NULL ,
	[remaining_qty] [decimal](18, 0) NULL ,
	[entry_date] [datetime] NULL ,
	[date_acquired] [datetime] NULL ,
	[cost] [decimal](18, 0) NULL ,
	[last_name] [varchar] (110) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[record_source] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
END
GO



if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[transaction_types]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[transaction_types] (
	[trans_type_no] [int] NOT NULL ,
	[trans_description] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[trans_description_2] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
END
else if NOT EXISTS (select * from dbo.syscolumns where name = 'trans_description_2' and id = object_id(N'[dbo].[transaction_types]'))
BEGIN
ALTER TABLE [dbo].[transaction_types] ADD 
	[trans_description_2] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[transfer_field_mapping]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[transfer_field_mapping] (
	[id] [int] IDENTITY (1, 1) NOT NULL ,
	[map_id] [int] NOT NULL ,
	[table_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[field_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[company_id] [int] NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[transfer_map]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[transfer_map] (
	[map_id] [int] IDENTITY (1, 1) NOT NULL ,
	[name] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[record_type] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[company_id] [int] NOT NULL 
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[ui_settings]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[ui_settings] (
	[user_id] [int] NOT NULL ,
	[setting_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[setting_type] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[setting_value] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[unit_of_measure]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[unit_of_measure] (
	[uom_id] [int] IDENTITY (1, 1) NOT NULL ,
	[item_id] [int] NOT NULL ,
	[supplier_id] [int] NOT NULL ,
	[uom_code] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[quantity_eaches] [decimal](18, 4) NULL ,
	[cost] [money] NULL ,
	[preferred_uom] [wtbool] NOT NULL ,
	[record_status] [record_status_type] NOT NULL ,
	[company_id] [int] NOT NULL ,
	[date_updated] [datetime] NULL 
) ON [PRIMARY]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[user_groups]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[user_groups](
	[group_id] [int] IDENTITY(1,1) NOT NULL,
	[group_name] [nvarchar](50) NOT NULL,
	[group_description] [nvarchar](500) NULL,
	[record_status] [record_status_type] NOT NULL,
	[company_id] [int] NOT NULL,
	 CONSTRAINT [PK_user_groups] PRIMARY KEY CLUSTERED 
	(
		[group_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]

	--add a default record here, so check constraint on UPG_Tables_users.sql can work
	SET IDENTITY_INSERT [user_groups] ON;

	INSERT INTO [dbo].[user_groups] (group_id, [group_name], [group_description] ,[record_status] ,[company_id])
    		VALUES (1, 'Admin Group', 'Administrative Group With All Rights', 4, 1)

	SET IDENTITY_INSERT [user_groups] OFF;
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[user_group_privileges]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[user_group_privileges] (
		[group_id] [int] NOT NULL ,
		[security_code] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NOT NULL,
	) ON [PRIMARY]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[user_group_sites]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[user_group_sites](
		[id] [int] IDENTITY(1000,1) NOT NULL,
		[group_id] [int] NOT NULL,
		[site_id] [int] NOT NULL,
	) ON [PRIMARY]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[user_group_reports]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[user_group_reports](
		[id] [int] IDENTITY(1000,1) NOT NULL,
		[group_id] [int] NOT NULL,
		[rpt_id] [int] NOT NULL,
	) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[user_privileges]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[user_privileges] (
	[user_id] [int] NOT NULL ,
	[security_code] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[record_status] [record_status_type] NOT NULL 
) ON [PRIMARY]
END
GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[users]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[users](
		[user_id] [int] IDENTITY(1,1) NOT NULL,
		[last_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[first_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[title] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[department] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[manager] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[user_logon] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[user_password] [wtpassword] NULL ,
		[changed_password] [wtbool] NULL ,
		[email] [varchar] (250) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NULL,
		[date_updated] [datetime] NULL,
		[group_id] [int] NOT NULL,
	 CONSTRAINT [PK_USER_UD] PRIMARY KEY CLUSTERED 
	(
		[user_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END
ELSE 
BEGIN
	IF NOT EXISTS (select * from dbo.syscolumns where name = 'email' and id = object_id(N'[dbo].[users]'))
	BEGIN
	ALTER TABLE [dbo].[users] ADD 
		[email] [varchar] (250) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
	END

	IF NOT EXISTS (select * from dbo.syscolumns where name = 'group_id' and id = object_id(N'[dbo].[users]'))
	BEGIN
		ALTER TABLE [dbo].[users] ADD [group_id] [int] NOT NULL CONSTRAINT [DF_users_group_id]  DEFAULT ((1))
		
		ALTER TABLE [dbo].[users]  WITH CHECK ADD  CONSTRAINT [FK_users_groups] FOREIGN KEY([group_id])
			REFERENCES [dbo].[user_groups] ([group_id])
		
		ALTER TABLE [dbo].[users] CHECK CONSTRAINT [FK_users_groups]
	END

	IF NOT EXISTS (select * from dbo.syscolumns where name = 'date_updated' and id = object_id(N'[dbo].[users]'))
	BEGIN
	ALTER TABLE [dbo].[users] ADD 
		[date_updated] [datetime] NULL
	END
END





if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[users_mobile]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[users_mobile] (
	[user_id] [int] NULL ,
	[type] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
END
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pick_order_history]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[pick_order_history](
	[pick_order_id] [int] NOT NULL,
	[order_number] [varchar](38) NOT NULL,
	[creation_date] [datetime] NULL,
	[last_modified_date] [datetime] NULL,
	[due_date] [datetime] NULL,
	[ship_date] [datetime] NULL,
	[order_status] [int] NOT NULL,
	[customer_id] [int] NULL,
	[tracking_number] [varchar](255) NULL,
	[is_canceled] [wtbool] NOT NULL DEFAULT ('F'),
	[company_id] [int] NOT NULL,
	[record_status] [record_status_type] NOT NULL,
	[line_item_count] [int] NULL,
	[backorder_id] [int] NULL,
	[is_printed] [wtbool] NULL,
	[print_no] [int] NULL DEFAULT (0),
	[last_printed_date] [datetime] NULL,
	[ref_number] [varchar](100) NULL,
	[customer_address_type_id] [int] NULL,
	[customer_address_record_type] [varchar](50) NULL,
	[ship_method_id] [int] NULL
) ON [PRIMARY]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[po_detail_history]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[po_detail_history](
	[po_detail_id] [int] NOT NULL,
	[po_id] [int] NOT NULL,
	[line_item_type] [int] NOT NULL DEFAULT (1),
	[item_id] [int] NOT NULL,
	[item_description] [nvarchar](255) NULL,
	[vendor_sku] [nvarchar](255) NULL,
	[uom_id] [int] NOT NULL DEFAULT (0),
	[quantity_ordered] [decimal](18, 4) NOT NULL DEFAULT (0),
	[quantity_received] [decimal](18, 4) NOT NULL DEFAULT (0),
	[quantity_original] [decimal](18, 4) NOT NULL DEFAULT (0),
	[cost] [money] NOT NULL,
	[company_id] [int] NOT NULL,
	[record_status] [record_status_type] NOT NULL
) ON [PRIMARY]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pick_order_detail_history]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[pick_order_detail_history](
	[pick_order_detail_id] [int] NOT NULL,
	[pick_order_id] [int] NOT NULL,
	[line_item_type] [int] NOT NULL,
	[item_id] [int] NOT NULL DEFAULT (0),
	[item_description] [varchar](255) NULL,
	[item_uom] [varchar](10) NULL,
	[request_quantity] [decimal](15, 4) NOT NULL DEFAULT (0),
	[picked_quantity] [decimal](15, 4) NOT NULL DEFAULT (0),
	[company_id] [int] NOT NULL,
	[record_status] [record_status_type] NOT NULL
) ON [PRIMARY]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pick_order_ext_history]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[pick_order_ext_history](
		[pick_order_id] [int] NOT NULL,
		[external_key] [varchar](100) NULL,
		[tax_percentage] [decimal](18, 4) NOT NULL DEFAULT ('0.00'),
		[shipping_handling] [decimal](18, 4) NOT NULL DEFAULT ('0.00'),
		[sales_tax_id] [int] NOT NULL DEFAULT ('0')
	) ON [PRIMARY]
END

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pick_order_detail_ext_history]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[pick_order_detail_ext_history](
	[pick_order_detail_id] [int] NOT NULL,
	[price] [money] NOT NULL DEFAULT ((0)),
	[sales_tax_code_id] [int] NOT NULL DEFAULT (1) ,
	[external_key] [varchar](100) NULL
) ON [PRIMARY]
END


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[po_master_history]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[po_master_history](
	[po_id] [int] NOT NULL,
	[po_type] [varchar](10) NOT NULL DEFAULT ('PO'),
	[po_number] [nvarchar](38) NOT NULL,
	[ref_number] [varchar](100) NOT NULL,
	[supplier_id] [int] NULL,
	[customer_id] [int] NULL,
	[order_date] [datetime] NULL,
	[due_date] [datetime] NULL,
	[ship_method_id] [int] NULL,
	[pay_method_id] [int] NULL,
	[po_status] [int] NOT NULL DEFAULT (1),
	[last_modified_date] [datetime] NULL,
	[company_id] [int] NOT NULL,
	[record_status] [record_status_type] NOT NULL,
	[record_status_date] [datetime] NULL DEFAULT (getdate()),
	[supplier_address_type_id] [int] NULL,
	[supplier_address_record_type] [varchar] (50) NULL,
	[shipping_address_type_id] [int] NULL,
	[shipping_address_record_type] [varchar] (50) NULL,
	[is_dropship] [wtbool] NOT NULL DEFAULT ('F'),
	[external_key] [varchar](100) NULL
) ON [PRIMARY]
END
ELSE
BEGIN
	if NOT EXISTS (select * from dbo.syscolumns where name = 'is_dropship' and id = object_id(N'[dbo].[po_master_history]'))
	BEGIN
		ALTER TABLE [dbo].[po_master_history] ADD [is_dropship] [wtbool] NOT NULL  DEFAULT ('F')
	END

	if NOT EXISTS (select * from dbo.syscolumns where name = 'external_key' and id = object_id(N'[dbo].[po_master_history]'))
	BEGIN
		ALTER TABLE [dbo].[po_master_history] ADD [external_key] [varchar](100) NULL
	END
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[report_extras]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[report_extras](
      [field_id] [int] NOT NULL,
      [field_type] [int] NOT NULL,
      [field_text] [text] NULL,
      [field_image] [image] NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
END
GO


/**********************************************************************************/
/****** Object:  Table [dbo].[user_site]    Script Date: 07/21/2008 08:38:16 ******/
/****** Added for Version 5 of InventoryControl                              ******/
/**********************************************************************************/

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[user_site]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[user_site](
	[id] [int] IDENTITY(1000,1) NOT NULL,
	[user_id] [int] NOT NULL,
	[site_id] [int] NOT NULL,
 CONSTRAINT [PK_ID] PRIMARY KEY CLUSTERED 
(
	[id] ASC
) ON [PRIMARY]
) ON [PRIMARY]
END
GO

------------------------
--  report_names table add a new column for report print orientation
-------------------------

if NOT EXISTS (select * from dbo.syscolumns where name = 'rpt_orientation' and id = object_id(N'[dbo].[report_names]'))
BEGIN
ALTER TABLE [dbo].[report_names] ADD
	[rpt_orientation] [nvarchar] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL DEFAULT ('P')
END
GO


/**************************************************************************************************/
/****** Object:  Table [dbo].[user_default_working_site]    Script Date: 08/23/2010 08:38:16 ******/
/****** Object:  Table [dbo].[attachments]  				Script Date: 02/24/2011 08:38:16 ******/
/****** Added for Version 6 of InventoryControl                                              ******/
/**************************************************************************************************/

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[user_default_working_site]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[user_default_working_site](
	[user_id] [int] NOT NULL,
	[type] [smallint] NOT NULL,
	[site_id] [int] NOT NULL,
	[company_id] [int] NULL,
 CONSTRAINT [PK_user_default_working_site] PRIMARY KEY CLUSTERED 
(
	[user_id] ASC,
	[type] ASC,
	[site_id] ASC
) ON [PRIMARY]
) ON [PRIMARY]
END
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[attachments]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[attachments] (
		[attach_id] [int] NOT NULL ,
		[attach_type] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[file_data_type] [int] NOT NULL CONSTRAINT [DF_attachments_file_data_type] DEFAULT (0),
		[file_name] [varchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[file_data] [image] NULL ,
		[is_default] [wtbool] NOT NULL CONSTRAINT [DF_attachments_is_default] DEFAULT ('F'),
		[record_status] [record_status_type] NOT NULL CONSTRAINT [DF_attachments_record_status] DEFAULT (1),
		[company_id] [int] NOT NULL
	) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
END
GO

/****** Object:  Table [dbo].[custom_values]    Script Date: 02/28/2011 23:00:43 ******/

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[custom_values]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[custom_values](
	[form_id] [int] NOT NULL,
	[custom_field] [varchar](30) NOT NULL,
	[value] [varchar](100) NOT NULL,
	[default] [wtbool] NULL,
	[order] [int] NULL,
	[record_status] [record_status_type] NOT NULL,
	[company_id] [int] NOT NULL,
 CONSTRAINT [PK_custom_values] PRIMARY KEY CLUSTERED 
(
	[form_id] ASC,
	[custom_field] ASC,
	[value] ASC
)WITH FILLFACTOR = 90 ON [PRIMARY]
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.syscolumns where name = 'usrdef_allow_user_key_in_value' and id = object_id(N'[dbo].[form_field_meta]'))
BEGIN
	ALTER TABLE [dbo].[form_field_meta] ADD 
	[usrdef_allow_user_key_in_value] [char](1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL CONSTRAINT [DF_form_field_meta_usrdef_allow_user_key_in_value]  DEFAULT ('T')
END
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[item_cost]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	CREATE TABLE [dbo].[item_cost](
		[rec_id] [int] IDENTITY(1,1) NOT NULL,
		[item_id] [int] NOT NULL,
		[site_id] [int] NOT NULL CONSTRAINT [DF_item_cost_site_id]  DEFAULT ((0)),
		[add_date] [datetime] NULL,
		[unit_cost] [decimal](18, 4) NOT NULL,
		[quantity] [decimal](18, 4) NOT NULL,
		[avg_cost] [decimal](21, 7) NOT NULL,
		[total_quantity] [decimal](18, 4) NOT NULL,
		[total_value] [decimal](18, 4) NOT NULL,
		[last_updated] [datetime] NOT NULL,
	 CONSTRAINT [PK_item_cost] PRIMARY KEY CLUSTERED 
	(
		[rec_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]

END

GO




IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[item_cost_history]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	CREATE TABLE [dbo].[item_cost_history](
		[rec_id] [int] NOT NULL,
		[item_id] [int] NOT NULL,
		[site_id] [int] NOT NULL,
		[add_date] [datetime] NULL,
		[unit_cost] [decimal](18, 4) NOT NULL,
		[quantity] [decimal](18, 4) NOT NULL,
		[avg_cost] [decimal](21, 7) NOT NULL,
		[total_quantity] [decimal](18, 4) NOT NULL,
		[total_value] [decimal](18, 4) NOT NULL,
		[last_updated] [datetime] NOT NULL,
		[backup_date] [datetime] NOT NULL
	) ON [PRIMARY]

	CREATE UNIQUE NONCLUSTERED INDEX [IX_item_cost_history] ON [dbo].[item_cost_history] 
	(
		[rec_id] ASC,
		[backup_date] ASC
	)ON [PRIMARY]

END

GO


if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[item_costing_method]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	CREATE TABLE [dbo].[item_costing_method](
		[costing_method_id] [int] NOT NULL,
		[method_name] [nvarchar](50) NOT NULL,
		[method_description] [nvarchar](250) NULL,
		[record_status] [record_status_type] NOT NULL,
		[company_id] [int] NOT NULL,
	 CONSTRAINT [PK_item_costing_method] PRIMARY KEY CLUSTERED 
	(
		[costing_method_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
	
END

GO



/****** Object:  Table [dbo].[supplier_ext]    Script Date: 04/21/2011 13:34:24 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[supplier_ext]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[supplier_ext](
	[supplier_id] [int] NOT NULL,
	[external_key] [varchar](100) NULL,
 CONSTRAINT [PK_supplier_ext] PRIMARY KEY CLUSTERED 
(
	[supplier_id] ASC
) ON [PRIMARY]
) ON [PRIMARY]
END
GO



IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[po_master_ext]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	DROP TABLE [dbo].[po_master_ext]
END
GO




/****** Object:  Table [dbo].[po_detail_ext]    Script Date: 04/21/2011 13:34:24 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[po_detail_ext]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[po_detail_ext](
		[po_detail_id] [int] NOT NULL,
		[external_key] [varchar](100) NULL,
	 CONSTRAINT [PK_po_detail_ext] PRIMARY KEY CLUSTERED 
	(
		[po_detail_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END
GO
SET ANSI_PADDING OFF
GO



/****** Object:  Table [dbo].[drop_ship_detail]    Script Date: 08/30/2012 10:15:13 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[drop_ship_detail]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[drop_ship_detail](
		[dropship_id] [int] IDENTITY(1,1) NOT NULL,
		[po_id] [int] NOT NULL,
		[po_detail_id] [int] NOT NULL,
		[pick_order_id] [int] NOT NULL,
		[pick_order_detail_id] [int] NOT NULL,
		[quantity] [decimal](18, 9) NOT NULL,
		[is_fulfilled] [wtbool] NOT NULL,
		[record_status] [record_status_type] NOT NULL,
		[company_id] [int] NOT NULL,
	 CONSTRAINT [PK_drop_ship_detail] PRIMARY KEY CLUSTERED 
	(
		[dropship_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END

GO
SET ANSI_PADDING OFF
GO




/****** Object:  Table [dbo].[manufacturer_ext]    Script Date: 04/21/2011 13:34:24 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[manufacturer_ext]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[manufacturer_ext](
	[manufacturer_id] [int] NOT NULL,
	[external_key] [varchar](100) NULL,
 CONSTRAINT [PK_manufacturer_ext] PRIMARY KEY CLUSTERED 
(
	[manufacturer_id] ASC
) ON [PRIMARY]
) ON [PRIMARY]
END
GO



/****** Object:  Table [dbo].[item_price_level_setting]    Script Date: 10/18/2011 17:05:16 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[item_price_level_setting]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[item_price_level_setting](
		[price_level_id] [int] NOT NULL,
		[item_id] [int] NOT NULL,
		[amount] [decimal](18, 9) NOT NULL,
		[is_percentage] [wtbool] NOT NULL
	) ON [PRIMARY]
END
GO
SET ANSI_PADDING OFF
GO




/****** Object:  Table [dbo].[price_level]    Script Date: 10/18/2011 17:05:51 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[price_level]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[price_level](
		[price_level_id] [int] IDENTITY(1,1) NOT NULL,
		[price_level_name] [nvarchar](255) NOT NULL,
		[external_key] [varchar](100) NULL,
		[record_status] [record_status_type] NOT NULL,
		[company_id] [int] NOT NULL,
	 CONSTRAINT [PK_price_level] PRIMARY KEY CLUSTERED 
	(
		[price_level_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]

END
GO
SET ANSI_PADDING OFF
GO





/****** Object:  Table [dbo].[sales_tax]    Script Date: 09/17/2012 11:16:10 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[sales_tax]') and OBJECTPROPERTY(id, N'IsUserTable') = 1) AND
   NOT EXISTS (select * from dbo.syscolumns where name = 'tax_default' and id = object_id(N'[dbo].[sales_tax]')) AND
   NOT EXISTS (select * from dbo.syscolumns where name = 'company_id' and id = object_id(N'[dbo].[sales_tax]'))
BEGIN
-- this is the old format sales_tax table that we generated back in 10/18/2011, we can safely drop it
	DROP TABLE [dbo].[sales_tax]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[sales_tax]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[sales_tax](
		[tax_id] [int] IDENTITY(1,1) NOT NULL,
		[tax_name] [nvarchar](31) NOT NULL,
		[tax_description] [nvarchar](4000) NOT NULL CONSTRAINT [DF_sales_tax_tax_description]  DEFAULT (''),
		[tax_rate] [decimal](18, 4) NOT NULL,
		[tax_default] [wtbool] NOT NULL CONSTRAINT [DF_sales_tax_tax_default]  DEFAULT ('F'),
		[external_key] [varchar](100) NULL,
		[record_status] [record_status_type] NOT NULL,
		[company_id] [int] NOT NULL CONSTRAINT [DF_sales_tax_company_id]  DEFAULT ((1)),
	 CONSTRAINT [PK_sales_tax] PRIMARY KEY CLUSTERED 
	(
		[tax_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END
GO
SET ANSI_PADDING OFF
GO

--in IC 6.3 database, we had a qb_option table that is imcomplete, we need to drop it first
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[qb_options]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	IF NOT EXISTS(select * from sys.columns where Name = N'lookup_key' and Object_ID = Object_ID(N'[dbo].[qb_options]'))    
	BEGIN
		DROP TABLE [dbo].[qb_options]
	END
END
GO

/****** Object:  Table [dbo].[qb_options]    Script Date: 09/17/2012 11:16:10 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[qb_options]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[qb_options](
		[qb_option_id] [int] IDENTITY(1,1) NOT NULL,
		[code] [nvarchar](50) NULL,
		[lookup_key] [int] NULL,
		[group_id] [int] NULL,
		[name] [nvarchar](255) NULL,
		[label] [nvarchar](255) NULL,
		[option_value] [nvarchar](255) NULL,
		[type] [nvarchar](20) NULL,
		[flag] [wtbool] NULL,
		[required] [wtbool] NOT NULL DEFAULT ('F'),
		[record_status] [record_status_type] NULL CONSTRAINT [DF_qb_options_record_status]  DEFAULT ((1)),
		[company_id] [int] NOT NULL CONSTRAINT [DF_qb_options_company_id]  DEFAULT ((1)),
		[admin] [wtbool] NULL CONSTRAINT [DF_qb_options_admin]  DEFAULT ('T'),
	 CONSTRAINT [PK_qb_options] PRIMARY KEY CLUSTERED 
	(
		[qb_option_id] ASC
	) ON [PRIMARY],
	 CONSTRAINT [IX_qb_options] UNIQUE NONCLUSTERED 
	(
		[code] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END
GO
SET ANSI_PADDING OFF
GO


/****** Object:  Table [dbo].[qw_options]    Script Date: 10/09/2013 09:52:10 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[qw_options]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[qw_options](
		[option_code] [nvarchar](255) NULL,
		[value] [nvarchar](255) NULL,
		[record_status] [record_status_type] NULL CONSTRAINT [DF_qw_options_record_status]  DEFAULT ((1)),
		[company_id] [int] NOT NULL CONSTRAINT [DF_qw_options_company_id]  DEFAULT ((1)),
	) ON [PRIMARY]
END
GO
SET ANSI_PADDING OFF
GO


/****** Object:  Table [dbo].[qw_line_types]    Script Date: 10/09/2013 09:52:10 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[qw_line_types]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[qw_line_types](
		[line_type] int NULL,
		[value] [nvarchar](255) NULL
	) ON [PRIMARY]
END
GO
SET ANSI_PADDING OFF
GO


/****** Object:  Table [dbo].[sales_tax_code]    Script Date: 07/23/2012 17:06:09 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[sales_tax_code]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[sales_tax_code](
		[tax_code_id] [int] IDENTITY(1,1) NOT NULL,
		[tax_code] [nvarchar](3) NOT NULL,
		[description] [nvarchar](31) NOT NULL CONSTRAINT [DF_sales_tax_code_description]  DEFAULT (''),
		[is_taxable] [wtbool] NOT NULL,
		[external_key] [nvarchar](100) NULL,
		[default_flag] [wtbool] NOT NULL CONSTRAINT [DF_sales_tax_code_default_flag]  DEFAULT ('F'),
		[company_id] [int] NOT NULL CONSTRAINT [DF_sales_tax_code_company_id]  DEFAULT ((1)),
		[record_status] [record_status_type] NOT NULL,
		[last_modified_date] [DATETIME] NOT NULL DEFAULT GETDATE(),
	 CONSTRAINT [PK_sales_tax_code] PRIMARY KEY CLUSTERED 
	(
		[tax_code_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END
ELSE
BEGIN
	IF NOT EXISTS (SELECT * FROM dbo.syscolumns WHERE name = 'last_modified_date' AND id = object_id(N'[dbo].[sales_tax_code]'))
	BEGIN
		ALTER TABLE [dbo].[sales_tax_code] ADD [last_modified_date] [DATETIME] NOT NULL  DEFAULT GETDATE()
	END
END
GO
SET ANSI_PADDING OFF
GO




-- These tables MUST BE CREATED AFTER Sales_tax and Sales_tax_code table


/****** Object:  Table [dbo].[customer_ext]    Script Date: 04/21/2011 13:34:24 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[customer_ext]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[customer_ext](
		[customer_id] [int] NOT NULL,
		[external_key] [varchar](100) NULL,
		[price_level_id] [int] NOT NULL DEFAULT (0),
		[sales_tax_code_id] [int] NOT NULL,
	 CONSTRAINT [PK_customer_ext] PRIMARY KEY CLUSTERED 
	(
		[customer_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END
ELSE 
BEGIN
	if NOT EXISTS (select * from dbo.syscolumns where name = 'price_level_id' and id = object_id(N'[dbo].[customer_ext]'))
	BEGIN
		ALTER TABLE [dbo].[customer_ext] ADD [price_level_id] [int] NOT NULL DEFAULT (0)
	END
	if NOT EXISTS (select * from dbo.syscolumns where name = 'sales_tax_code_id' and id = object_id(N'[dbo].[customer_ext]'))
	BEGIN
		ALTER TABLE [dbo].[customer_ext] ADD [sales_tax_code_id] [int] NOT NULL DEFAULT (0)
	END
END
GO



/****** Object:  Table [dbo].[item_ext]    Script Date: 04/21/2011 13:34:24 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[item_ext]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[item_ext](
		[item_id] [int] NOT NULL,	
		[sales_tax_code_id] [int] NOT NULL CONSTRAINT [DF_item_ext_sales_tax_code_id]  DEFAULT (0),
		[account_category_id][int] NOT NULL CONSTRAINT [DF_item_ext_account_category_id] DEFAULT (0),
		[external_key] [varchar](100) NULL,
	 CONSTRAINT [PK_item_ext] PRIMARY KEY CLUSTERED 
	(
		[item_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END
else 
begin
	if NOT EXISTS (select * from dbo.syscolumns where name = 'sales_tax_code_id' and id = object_id(N'[dbo].[item_ext]'))
	BEGIN		
		ALTER TABLE [dbo].[item_ext] ADD [sales_tax_code_id] [int] NOT NULL  CONSTRAINT [DF_item_ext_sales_tax_code_id]  DEFAULT (0)
	END

	if  EXISTS (select * from dbo.syscolumns where name = 'tax_code' and id = object_id(N'[dbo].[item_ext]'))
	BEGIN
		ALTER TABLE [dbo].[item_ext] DROP CONSTRAINT [DF_item_ext_tax_code]	
		ALTER TABLE item_ext DROP COLUMN tax_code	
	END

	if NOT EXISTS (select * from dbo.syscolumns where name = 'account_category_id' and id = object_id(N'[dbo].[item_ext]'))
	BEGIN
		ALTER TABLE [dbo].[item_ext] ADD [account_category_id][int] NOT NULL CONSTRAINT [DF_item_ext_account_category_id] DEFAULT (0)
	END
end
GO
SET ANSI_PADDING OFF
GO



/****** Object:  Table [dbo].[pick_order_ext]    Script Date: 04/21/2011 13:34:24 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pick_order_ext]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[pick_order_ext](
		[pick_order_id] [int] NOT NULL,
		[external_key] [varchar](100) NULL,
		[tax_percentage] [decimal](18, 4) NOT NULL CONSTRAINT [DF_pick_order_ext_tax_percentage]  DEFAULT ('0.00'),
		[shipping_handling] [decimal](18, 4) NOT NULL CONSTRAINT [DF_pick_order_ext_shipping_handling]  DEFAULT ('0.00'),
		[sales_tax_id] [int] NOT NULL CONSTRAINT [DF_pick_order_ext_sales_tax_id]  DEFAULT ('0'),
	 CONSTRAINT [PK_pick_order_ext] PRIMARY KEY CLUSTERED 
	(
		[pick_order_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END
else 
BEGIN
	if NOT EXISTS (select * from dbo.syscolumns where name = 'tax_percentage' and id = object_id(N'[dbo].[pick_order_ext]'))
	BEGIN
		ALTER TABLE [dbo].[pick_order_ext] ADD [tax_percentage] [decimal](18, 4) NOT NULL CONSTRAINT [DF_pick_order_ext_tax_percentage]  DEFAULT ('0.00')
	END
	if NOT EXISTS (select * from dbo.syscolumns where name = 'shipping_handling' and id = object_id(N'[dbo].[pick_order_ext]'))
	BEGIN
		ALTER TABLE [dbo].[pick_order_ext] ADD [shipping_handling] [decimal](18, 4) NOT NULL CONSTRAINT [DF_pick_order_ext_shipping_handling]  DEFAULT ('0.00')
	END
	if NOT EXISTS (select * from dbo.syscolumns where name = 'sales_tax_id' and id = object_id(N'[dbo].[pick_order_ext]'))
	BEGIN
		ALTER TABLE [dbo].[pick_order_ext] ADD [sales_tax_id] [int] NOT NULL CONSTRAINT [DF_pick_order_ext_sales_tax_id] DEFAULT('0')
	END
END
GO
SET ANSI_PADDING OFF
GO


/****** Object:  Table [dbo].[pick_order_detail_ext]    Script Date: 04/21/2011 13:34:24 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pick_order_detail_ext]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[pick_order_detail_ext](
	[pick_order_detail_id] [int] NOT NULL,
	[price] [money] NOT NULL CONSTRAINT [DF_pick_order_detail_ext_price]  DEFAULT ((0)),
	[sales_tax_code_id] [int] NOT NULL CONSTRAINT [DF_pick_order_detail_ext_sales_tax_code_id]  DEFAULT (1) ,
	[external_key] [varchar](100) NULL,
 CONSTRAINT [PK_pick_order_detail_ext] PRIMARY KEY CLUSTERED 
(
	[pick_order_detail_id] ASC
) ON [PRIMARY]
) ON [PRIMARY]
END
else 
begin
if NOT EXISTS (select * from dbo.syscolumns where name = 'sales_tax_code_id' and id = object_id(N'[dbo].[pick_order_detail_ext]'))
BEGIN		
	ALTER TABLE [dbo].[pick_order_detail_ext] ADD [sales_tax_code_id] [int] NOT NULL  CONSTRAINT [DF_pick_order_detail_ext_sales_tax_code_id]  DEFAULT (1)
END

if NOT EXISTS (select * from dbo.syscolumns where name = 'price' and id = object_id(N'[dbo].[pick_order_detail_ext]'))
BEGIN
	ALTER TABLE [dbo].[pick_order_detail_ext] ADD [price] [money] NOT NULL CONSTRAINT [DF_pick_order_detail_ext_price]  DEFAULT ((0)),
	[tax_code] [nvarchar](50) NOT NULL CONSTRAINT [DF_pick_order_detail_ext_tax_code]  DEFAULT ('1')
END

if EXISTS (select * from dbo.syscolumns where name = 'tax_code' and id = object_id(N'[dbo].[pick_order_detail_ext]'))
BEGIN
	ALTER TABLE [dbo].[pick_order_detail_ext] DROP CONSTRAINT [DF_pick_order_detail_ext_tax_code]	
	ALTER TABLE [dbo].[pick_order_detail_ext] DROP COLUMN tax_code
END
END
GO

SET ANSI_PADDING OFF
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[filters]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
--print 'reached rename of filters'
	EXEC sp_rename 'filters', 'web_filters'
	EXEC sp_rename 'PK_filters', 'PK_web_filters'
END

/****** Object:  Table [dbo].[filter]    Script Date: 08/09/2009 17:08:09 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[filter]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

CREATE TABLE [dbo].[filter](
	[filter_id] [int] IDENTITY(1,1) NOT NULL,
	[calling_form_id] [int] NOT NULL,
	[filter_name] [nvarchar](255) NOT NULL,
	[filter_desc] [nvarchar](1000) NULL,
	[is_default] [wtbool] NOT NULL,
	[is_global] [wtbool] NOT NULL,
	[user_id] [int] NOT NULL,
	[record_status] [record_status_type] NOT NULL,
	[company_id] [int] NOT NULL,
	[date_updated] [datetime] NULL,
	[dont_apply] [dbo].[wtbool] NULL
) ON [PRIMARY]

END
GO

IF NOT EXISTS (select * from dbo.syscolumns where name = 'dont_apply' and id = object_id(N'[dbo].[filter]'))
BEGIN
ALTER TABLE [dbo].[filter] ADD 
	[dont_apply] [dbo].[wtbool] NULL
END

GO

SET ANSI_PADDING OFF
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[filter_details]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	IF NOT EXISTS (select * from sys.columns where Name = N'selected_form_id' and Object_ID = Object_ID(N'[dbo].[filter_details]'))
	BEGIN
	--print 'reached rename of filter details'
		EXEC sp_rename 'filter_details', 'web_filter_details'
		EXEC sp_rename 'PK_filter_details', 'PK_web_filter_details'
	END
END
GO


/****** Object:  Table [dbo].[filter_details]    Script Date: 08/09/2009 17:09:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[filter_details]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[filter_details](
	[rec_id] [int] IDENTITY(1,1) NOT NULL,
	[filter_id] [int] NOT NULL,
	[form_id] [int] NOT NULL,
	[user_id] [int] NOT NULL,
	[company_id] [int] NOT NULL,
	[selected_form_id] [int] NULL,
	[field_id] [int] NULL,
	[device_name] [varchar](255) NULL,
	[field_value] [varchar](255) NULL,
	[filter] [varchar](6800) NULL,
	[whole_word_flag] [wtbool] NULL,
	[advanced_flag] [wtbool] NOT NULL CONSTRAINT [DF_filter_details_advanced_flag]  DEFAULT ('F'),
	[find_all_flag] [wtbool] NULL,
 CONSTRAINT [PK_filter_details] PRIMARY KEY CLUSTERED 
(
	[rec_id] ASC
) ON [PRIMARY]
) ON [PRIMARY]
END
GO
SET ANSI_PADDING OFF

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[filter_grid_settings]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[filter_grid_settings](
	[filter_id] [int] NULL,
	[form_id] [int] NULL,
	[col_name] [nvarchar](50) NOT NULL,
	[col_order] [int] NOT NULL,
	[sort_order] [nvarchar](50) NULL,
	[width] [decimal](18, 0) NOT NULL,
	[visible] [wtbool] NOT NULL,
	[group_level] [int] NULL,
	[user_id] [int] NOT NULL,
	[company_id] [int] NOT NULL,
	[record_status] [record_status_type] NOT NULL
) ON [PRIMARY]
END
GO
SET ANSI_PADDING OFF

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[filter_form_settings]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[filter_form_settings](
	[filter_id] [int] NULL,
	[form_id] [int] NULL,
	[xpos] [int] NOT NULL CONSTRAINT [DF_filter_form_settings_top_pos]  DEFAULT (0),
	[ypos] [int] NOT NULL CONSTRAINT [DF_filter_form_settings_left_pos]  DEFAULT (0),
	[width] [decimal](18, 0) NOT NULL,
	[heigth] [decimal](18, 0) NOT NULL,
	[user_id] [int] NOT NULL,
	[company_id] [int] NOT NULL,
	[record_status] [record_status_type] NOT NULL
) ON [PRIMARY]
END
GO
SET ANSI_PADDING OFF
GO

update item_group_spec 
set record_status = 2 
where item_group_spec.item_id in (select item_id 
									from item 
									where (item_type = 4 or item_type = 5) and record_status = 2 and company_id = 1) 
and company_id = 1

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[account_categories]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[account_categories](
	[account_category_id][int] Identity(1,1) NOT NULL,
	[accnt_cat_name][nvarchar](31) NOT NULL,
	[accnt_cat_description][nvarchar](255) NOT NULL,
	[accnt_type][int] NOT NULL,
	[record_status][dbo].[record_status_type] NOT NULL,
	[company_id][int] NOT NULL
) ON [PRIMARY]
END
GO

if NOT EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[account_categories_types]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[account_categories_types] (
	[account_type_no] [int] NOT NULL ,
	[account_type_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[account_type_description] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	
) ON [PRIMARY]
END

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[account_mappings]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[account_mappings](
		[account_mappings_id] [int] IDENTITY(1,1) NOT NULL,
		[account_categories_id] [int] NOT NULL,
		[income_account] [nvarchar](255) NULL,
		[income_account_id] [nvarchar](255) NULL,
		[expense_account] [nvarchar](255) NULL,
		[expense_account_id] [nvarchar](255) NULL,
		[cogs_account] [nvarchar](255) NULL,
		[cogs_account_id] [nvarchar](255) NULL,
		[asset_account] [nvarchar](255) NULL,
		[asset_account_id] [nvarchar](255) NULL,
		[memo] [nvarchar](255) NULL,
		[record_status] [record_status_type] NULL CONSTRAINT [DF_account_mappings_record_status]  DEFAULT ((1)),
		[company_id] [int] NOT NULL CONSTRAINT [DF_account_mappings_company_id]  DEFAULT ((1))
	) ON [PRIMARY]
END
GO
SET ANSI_PADDING OFF
GO












------ Keep the following section at the bottom of this file!!

if	EXISTS (select * from dbo.syscolumns where name = 'inventoried' and id = object_id(N'[dbo].[item]')) AND
	NOT EXISTS (select * from dbo.syscolumns where name = 'inventoried_2' and id = object_id(N'[dbo].[item]'))
BEGIN
	PRINT 'found inventoried, but not inventoried_2, adding inventoried_2'
	ALTER TABLE [dbo].[item] ADD 
		[inventoried_2] [wtbool] NOT NULL CONSTRAINT [DF_item_inventoried2] DEFAULT ('T') 
END
GO

if	EXISTS (select * from dbo.syscolumns where name = 'inventoried' and id = object_id(N'[dbo].[item]')) AND
	EXISTS (select * from dbo.syscolumns where name = 'item_type' and id = object_id(N'[dbo].[item]'))
BEGIN
	print 'found both inventoried and item_type'
	EXECUTE('UPDATE item SET item_type = 
			CASE
				WHEN (inventoried = ''T'') THEN 1
				ELSE  2
			END')
END
ELSE
BEGIN
	print 'NOT finding... both inventoried and item_type'
END
GO

if	EXISTS (select * from dbo.syscolumns where name = 'inventoried' and id = object_id(N'[dbo].[item]')) AND
	EXISTS (select * from dbo.syscolumns where name = 'inventoried_2' and id = object_id(N'[dbo].[item]'))
BEGIN
	PRINT 'DROP COLUMN [inventoried]'
	EXECUTE('UPDATE item SET inventoried_2 = inventoried')

	IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'DF_item_inventoried') and OBJECTPROPERTY(id, N'IsDefaultCnst') = 1)
	BEGIN
		ALTER TABLE [dbo].[item] DROP CONSTRAINT [DF_item_inventoried]
	END
	
	ALTER TABLE [dbo].[item] DROP COLUMN [inventoried]
END
GO

------ Keep the above section at the bottom of this file!!
















